<?php
/**
 * CustomerAccountApi
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Orbipay REST API
 *
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.7.0
 * Contact: support@billerpayments.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.4.1-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Api;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Exception\RequestException;
use GuzzleHttp\Psr7\MultipartStream;
use GuzzleHttp\Psr7\Request;
use GuzzleHttp\RequestOptions;
use Orbipay\PaymentsApi\Client\ApiException;
use Orbipay\PaymentsApi\Client\Configuration;
use Orbipay\PaymentsApi\Client\HeaderSelector;
use Orbipay\PaymentsApi\Client\ObjectSerializer;
use Psr\Http\Message\ResponseInterface;
use Orbipay\PaymentsApi\Client\CommonUtil;
use Orbipay\PaymentsApi\Client\AuthenticationUtil;
use GuzzleHttp\Exception\ConnectException;
use lf4php\LoggerFactory;

/**
 * CustomerAccountApi Class Doc Comment
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class CustomerAccountApi
{
    /**
     * @var ClientInterface
     */
    protected $client;

    /**
     * @var Configuration
     */
    protected $config;

    /**
     * @var HeaderSelector
     */
    protected $headerSelector;

    /**
     * @param ClientInterface $client
     * @param Configuration   $config
     * @param HeaderSelector  $selector
     */
    public function __construct(
        ClientInterface $client = null,
        Configuration $config = null,
        HeaderSelector $selector = null
    ) {
        $this->client = $client ?: new Client();
        $this->config = $config ?: new Configuration();
        $this->headerSelector = $selector ?: new HeaderSelector();
    }

    /**
     * @return Configuration
     */
    public function getConfig()
    {
        return $this->config;
    }

    /**
     * Operation renewCustomerAccount
     *
     * Renew Customer Account
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp. (required)
     * @param  string $idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details. (required)
     * @param  string $requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent. (required)
     * @param  string $id_customer_account The unique identifier assigned by Orbipay to the Customer Account. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  RenewCustomerAccountRequest $renew_customer_account_request JSON containing all the attributes of the Customer account to be renewed. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Orbipay\PaymentsApi\Client\Model\CustomerAccountResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function renewCustomerAccount($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer_account, $id_customer, $renew_customer_account_request, $x_opay_headers = null)
    {
         $response = $this->renewCustomerAccountWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer_account, $id_customer, $renew_customer_account_request, $x_opay_headers);
        return $response;
    }

    /**
     * Operation renewCustomerAccountWithHttpInfo
     *
     * Renew Customer Account
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp. (required)
     * @param  string $idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details. (required)
     * @param  string $requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent. (required)
     * @param  string $id_customer_account The unique identifier assigned by Orbipay to the Customer Account. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  RenewCustomerAccountRequest $renew_customer_account_request JSON containing all the attributes of the Customer account to be renewed. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Orbipay\PaymentsApi\Client\Model\CustomerAccountResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function renewCustomerAccountWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer_account, $id_customer, $renew_customer_account_request, $x_opay_headers = null)
    {
        $returnType = '\Orbipay\PaymentsApi\Client\Model\CustomerAccountResponse';
        list($request, $_tempBody, $formParams, $masked_authentication_data) = $this->renewCustomerAccountRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer_account, $id_customer, $renew_customer_account_request, $x_opay_headers);
		$logger = LoggerFactory::getLogger(__CLASS__);
        try {
            $options = $this->createHttpClientOption();
            try {
             	$isTimedOut = false;
             	if($logger->isDebugEnabled()){
             		$logger->debug('Connect TimeOut :'.$options[RequestOptions::TIMEOUT]);
             		$logger->debug('Read TimeOut :'.$options[RequestOptions::TIMEOUT]);
             	}
             	$logger->info('Sending Request to Service');
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
            	$logger->info('Receive Response from Service : HTTP Status Code :'.$e->getCode());
            	if($e instanceof ConnectException){
					$logger->warn("[{$e->getCode()}] {$e->getMessage()}");
                    $isTimedOut = true;
                }
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null, CommonUtil::get_masked_string(CommonUtil::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                ,$isTimedOut);
            }

            $statusCode = $response->getStatusCode();
			$logger->info('Receive Response from Service : HTTP Status Code :'.$statusCode);
            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody(), CommonUtil::get_masked_string(CommonUtil::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 201:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Model\CustomerAccountResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Model\ErrorResponseVo',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 409:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Model\ErrorResponseVo',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 422:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Model\ErrorResponseVo',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }


    /**
     * Create request for operation 'renewCustomerAccount'
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp. (required)
     * @param  string $idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details. (required)
     * @param  string $requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent. (required)
     * @param  string $id_customer_account The unique identifier assigned by Orbipay to the Customer Account. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  RenewCustomerAccountRequest $renew_customer_account_request JSON containing all the attributes of the Customer account to be renewed. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @throws \InvalidArgumentException
     * @return array
     */
    protected function renewCustomerAccountRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer_account, $id_customer, $renew_customer_account_request, $x_opay_headers = null)
    {
    
     $logger = LoggerFactory::getLogger(__CLASS__);
    
        // verify the required parameter 'id_customer_account' is set
        if ($id_customer_account === null || (is_array($id_customer_account) && count($id_customer_account) === 0) || strlen($id_customer_account) === 0) {
     		$logger->error('Missing the required parameter $id_customer_account');
           throw new \InvalidArgumentException(
                 'Missing the required parameter $id_customer_account'
             );
        }
        // verify the required parameter 'id_customer' is set
        if ($id_customer === null || (is_array($id_customer) && count($id_customer) === 0) || strlen($id_customer) === 0) {
     		$logger->error('Missing the required parameter $id_customer');
           throw new \InvalidArgumentException(
                 'Missing the required parameter $id_customer'
             );
        }
       
		$method = 'POST';
        $resourcePath = '/customers/{ID_CUSTOMER}/customeraccounts/{ID_CUSTOMER_ACCOUNT}/renew';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($channel !== null) {
            $headerParams['channel'] = ObjectSerializer::toHeaderValue($channel);
        }
        // header params
        if ($client_key !== null) {
            $headerParams['client_key'] = ObjectSerializer::toHeaderValue($client_key);
        }
        // header params
        if ($product !== null) {
            $headerParams['product'] = ObjectSerializer::toHeaderValue($product);
        }
        // header params
        if ($timestamp !== null) {
            $headerParams['timestamp'] = ObjectSerializer::toHeaderValue($timestamp);
        }
        // header params
        if ($idempotent_request_key !== null) {
            $headerParams['idempotent_request_key'] = ObjectSerializer::toHeaderValue($idempotent_request_key);
        }
        // header params
        if ($requestor_type !== null) {
            $headerParams['requestor_type'] = ObjectSerializer::toHeaderValue($requestor_type);
        }
        // header params
        if ($requestor !== null) {
            $headerParams['requestor'] = ObjectSerializer::toHeaderValue($requestor);
        }
        // header params
        if ($x_opay_headers !== null) {
            $headerParams['X-OPAY-Headers'] = ObjectSerializer::toHeaderValue($x_opay_headers);
        }

        // path params
        if ($id_customer_account !== null) {
            $resourcePath = str_replace(
                '{' . 'ID_CUSTOMER_ACCOUNT' . '}',
                ObjectSerializer::toPathValue($id_customer_account),
                $resourcePath
            );
        }
        // path params
        if ($id_customer !== null) {
            $resourcePath = str_replace(
                '{' . 'ID_CUSTOMER' . '}',
                ObjectSerializer::toPathValue($id_customer),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;
        if (isset($renew_customer_account_request)) {
            $_tempBody = $renew_customer_account_request;
        }

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/json']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }
        
        if($logger->isDebugEnabled()){
            $logger->debug('HTTP Method     :'.$method);
            $logger->debug('HTTP URL        :'.$this->config->getHost() . $resourcePath);
        }
        

        // this endpoint requires API key authentication
         list($hash, $masked_authentication_data) = AuthenticationUtil::computeHMACSHA256Hash($method, $resourcePath, $headerParams, $queryParams, $formParams, $_tempBody, $this->getConfig()->getClientSignatureKey());

        $headerParams['Authorization'] = "OPAY1-HMAC-SHA256" . " Credential=" . $this->getConfig()->getClientKey() . ",Signature=" . $hash;

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

		if($logger->isDebugEnabled()){
			$logger->debug('Request Headers  :'.json_encode($headers));
		}
		
        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return [ new Request(
            $method,
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        ), $_tempBody, $formParams, $masked_authentication_data];
    }

    /**
     * Operation retrieveCustomerAccount
     *
     * Get Customer Account
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp. (required)
     * @param  string $idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details. (required)
     * @param  string $requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent. (required)
     * @param  string $id_customer_account The unique identifier assigned by Orbipay to the Customer Account. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Orbipay\PaymentsApi\Client\Model\CustomerAccountResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function retrieveCustomerAccount($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer_account, $id_customer, $x_opay_headers = null)
    {
         $response = $this->retrieveCustomerAccountWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer_account, $id_customer, $x_opay_headers);
        return $response;
    }

    /**
     * Operation retrieveCustomerAccountWithHttpInfo
     *
     * Get Customer Account
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp. (required)
     * @param  string $idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details. (required)
     * @param  string $requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent. (required)
     * @param  string $id_customer_account The unique identifier assigned by Orbipay to the Customer Account. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Orbipay\PaymentsApi\Client\Model\CustomerAccountResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function retrieveCustomerAccountWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer_account, $id_customer, $x_opay_headers = null)
    {
        $returnType = '\Orbipay\PaymentsApi\Client\Model\CustomerAccountResponse';
        list($request, $_tempBody, $formParams, $masked_authentication_data) = $this->retrieveCustomerAccountRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer_account, $id_customer, $x_opay_headers);
		$logger = LoggerFactory::getLogger(__CLASS__);
        try {
            $options = $this->createHttpClientOption();
            try {
             	$isTimedOut = false;
             	if($logger->isDebugEnabled()){
             		$logger->debug('Connect TimeOut :'.$options[RequestOptions::TIMEOUT]);
             		$logger->debug('Read TimeOut :'.$options[RequestOptions::TIMEOUT]);
             	}
             	$logger->info('Sending Request to Service');
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
            	$logger->info('Receive Response from Service : HTTP Status Code :'.$e->getCode());
            	if($e instanceof ConnectException){
					$logger->warn("[{$e->getCode()}] {$e->getMessage()}");
                    $isTimedOut = true;
                }
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null, CommonUtil::get_masked_string(CommonUtil::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                ,$isTimedOut);
            }

            $statusCode = $response->getStatusCode();
			$logger->info('Receive Response from Service : HTTP Status Code :'.$statusCode);
            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody(), CommonUtil::get_masked_string(CommonUtil::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Model\CustomerAccountResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Model\ErrorResponseVo',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 409:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Model\ErrorResponseVo',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 422:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Model\ErrorResponseVo',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }


    /**
     * Create request for operation 'retrieveCustomerAccount'
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp. (required)
     * @param  string $idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details. (required)
     * @param  string $requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent. (required)
     * @param  string $id_customer_account The unique identifier assigned by Orbipay to the Customer Account. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     *
     * @throws \InvalidArgumentException
     * @return array
     */
    protected function retrieveCustomerAccountRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer_account, $id_customer, $x_opay_headers = null)
    {
    
     $logger = LoggerFactory::getLogger(__CLASS__);
    
        // verify the required parameter 'id_customer_account' is set
        if ($id_customer_account === null || (is_array($id_customer_account) && count($id_customer_account) === 0) || strlen($id_customer_account) === 0) {
     		$logger->error('Missing the required parameter $id_customer_account');
           throw new \InvalidArgumentException(
                 'Missing the required parameter $id_customer_account'
             );
        }
        // verify the required parameter 'id_customer' is set
        if ($id_customer === null || (is_array($id_customer) && count($id_customer) === 0) || strlen($id_customer) === 0) {
     		$logger->error('Missing the required parameter $id_customer');
           throw new \InvalidArgumentException(
                 'Missing the required parameter $id_customer'
             );
        }
       
		$method = 'GET';
        $resourcePath = '/customers/{ID_CUSTOMER}/customeraccounts/{ID_CUSTOMER_ACCOUNT}';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // header params
        if ($channel !== null) {
            $headerParams['channel'] = ObjectSerializer::toHeaderValue($channel);
        }
        // header params
        if ($client_key !== null) {
            $headerParams['client_key'] = ObjectSerializer::toHeaderValue($client_key);
        }
        // header params
        if ($product !== null) {
            $headerParams['product'] = ObjectSerializer::toHeaderValue($product);
        }
        // header params
        if ($timestamp !== null) {
            $headerParams['timestamp'] = ObjectSerializer::toHeaderValue($timestamp);
        }
        // header params
        if ($idempotent_request_key !== null) {
            $headerParams['idempotent_request_key'] = ObjectSerializer::toHeaderValue($idempotent_request_key);
        }
        // header params
        if ($requestor_type !== null) {
            $headerParams['requestor_type'] = ObjectSerializer::toHeaderValue($requestor_type);
        }
        // header params
        if ($requestor !== null) {
            $headerParams['requestor'] = ObjectSerializer::toHeaderValue($requestor);
        }
        // header params
        if ($x_opay_headers !== null) {
            $headerParams['X-OPAY-Headers'] = ObjectSerializer::toHeaderValue($x_opay_headers);
        }

        // path params
        if ($id_customer_account !== null) {
            $resourcePath = str_replace(
                '{' . 'ID_CUSTOMER_ACCOUNT' . '}',
                ObjectSerializer::toPathValue($id_customer_account),
                $resourcePath
            );
        }
        // path params
        if ($id_customer !== null) {
            $resourcePath = str_replace(
                '{' . 'ID_CUSTOMER' . '}',
                ObjectSerializer::toPathValue($id_customer),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }
        
        if($logger->isDebugEnabled()){
            $logger->debug('HTTP Method     :'.$method);
            $logger->debug('HTTP URL        :'.$this->config->getHost() . $resourcePath);
        }
        

        // this endpoint requires API key authentication
         list($hash, $masked_authentication_data) = AuthenticationUtil::computeHMACSHA256Hash($method, $resourcePath, $headerParams, $queryParams, $formParams, $_tempBody, $this->getConfig()->getClientSignatureKey());

        $headerParams['Authorization'] = "OPAY1-HMAC-SHA256" . " Credential=" . $this->getConfig()->getClientKey() . ",Signature=" . $hash;

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

		if($logger->isDebugEnabled()){
			$logger->debug('Request Headers  :'.json_encode($headers));
		}
		
        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return [ new Request(
            $method,
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        ), $_tempBody, $formParams, $masked_authentication_data];
    }

    /**
     * Operation retrieveCustomerAccounts
     *
     * Retrieve Customer Accounts
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp. (required)
     * @param  string $idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details. (required)
     * @param  string $requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     * @param  string $page_size The maximum number of objects returned in the query. (optional)
     * @param  string $account_number The Account Number to get details of. (optional)
     * @param  string[] $status The status of the customer&#39;s account in Orbipay. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2.... (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Orbipay\PaymentsApi\Client\Model\CustomerAccountsResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function retrieveCustomerAccounts($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer, $x_opay_headers = null, $page_size = null, $account_number = null, $status = null)
    {
         $response = $this->retrieveCustomerAccountsWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer, $x_opay_headers, $page_size, $account_number, $status);
        return $response;
    }

    /**
     * Operation retrieveCustomerAccountsWithHttpInfo
     *
     * Retrieve Customer Accounts
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp. (required)
     * @param  string $idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details. (required)
     * @param  string $requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     * @param  string $page_size The maximum number of objects returned in the query. (optional)
     * @param  string $account_number The Account Number to get details of. (optional)
     * @param  string[] $status The status of the customer&#39;s account in Orbipay. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2.... (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Orbipay\PaymentsApi\Client\Model\CustomerAccountsResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function retrieveCustomerAccountsWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer, $x_opay_headers = null, $page_size = null, $account_number = null, $status = null)
    {
        $returnType = '\Orbipay\PaymentsApi\Client\Model\CustomerAccountsResponse';
        list($request, $_tempBody, $formParams, $masked_authentication_data) = $this->retrieveCustomerAccountsRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer, $x_opay_headers, $page_size, $account_number, $status);
		$logger = LoggerFactory::getLogger(__CLASS__);
        try {
            $options = $this->createHttpClientOption();
            try {
             	$isTimedOut = false;
             	if($logger->isDebugEnabled()){
             		$logger->debug('Connect TimeOut :'.$options[RequestOptions::TIMEOUT]);
             		$logger->debug('Read TimeOut :'.$options[RequestOptions::TIMEOUT]);
             	}
             	$logger->info('Sending Request to Service');
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
            	$logger->info('Receive Response from Service : HTTP Status Code :'.$e->getCode());
            	if($e instanceof ConnectException){
					$logger->warn("[{$e->getCode()}] {$e->getMessage()}");
                    $isTimedOut = true;
                }
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null, CommonUtil::get_masked_string(CommonUtil::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                ,$isTimedOut);
            }

            $statusCode = $response->getStatusCode();
			$logger->info('Receive Response from Service : HTTP Status Code :'.$statusCode);
            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody(), CommonUtil::get_masked_string(CommonUtil::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Model\CustomerAccountsResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Model\ErrorResponseVo',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 409:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Model\ErrorResponseVo',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 422:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Model\ErrorResponseVo',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }


    /**
     * Create request for operation 'retrieveCustomerAccounts'
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp. (required)
     * @param  string $idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details. (required)
     * @param  string $requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     * @param  string $page_size The maximum number of objects returned in the query. (optional)
     * @param  string $account_number The Account Number to get details of. (optional)
     * @param  string[] $status The status of the customer&#39;s account in Orbipay. This can take multiple values in the format key&#x3D;value1&amp;key&#x3D;value2.... (optional)
     *
     * @throws \InvalidArgumentException
     * @return array
     */
    protected function retrieveCustomerAccountsRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer, $x_opay_headers = null, $page_size = null, $account_number = null, $status = null)
    {
    
     $logger = LoggerFactory::getLogger(__CLASS__);
    
        // verify the required parameter 'id_customer' is set
        if ($id_customer === null || (is_array($id_customer) && count($id_customer) === 0) || strlen($id_customer) === 0) {
     		$logger->error('Missing the required parameter $id_customer');
           throw new \InvalidArgumentException(
                 'Missing the required parameter $id_customer'
             );
        }
       
		$method = 'POST';
        $resourcePath = '/customers/{ID_CUSTOMER}/customeraccounts/lists';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($page_size !== null) {
            $queryParams['page_size'] = ObjectSerializer::toQueryValue($page_size);
        }
        // header params
        if ($channel !== null) {
            $headerParams['channel'] = ObjectSerializer::toHeaderValue($channel);
        }
        // header params
        if ($client_key !== null) {
            $headerParams['client_key'] = ObjectSerializer::toHeaderValue($client_key);
        }
        // header params
        if ($product !== null) {
            $headerParams['product'] = ObjectSerializer::toHeaderValue($product);
        }
        // header params
        if ($timestamp !== null) {
            $headerParams['timestamp'] = ObjectSerializer::toHeaderValue($timestamp);
        }
        // header params
        if ($idempotent_request_key !== null) {
            $headerParams['idempotent_request_key'] = ObjectSerializer::toHeaderValue($idempotent_request_key);
        }
        // header params
        if ($requestor_type !== null) {
            $headerParams['requestor_type'] = ObjectSerializer::toHeaderValue($requestor_type);
        }
        // header params
        if ($requestor !== null) {
            $headerParams['requestor'] = ObjectSerializer::toHeaderValue($requestor);
        }
        // header params
        if ($x_opay_headers !== null) {
            $headerParams['X-OPAY-Headers'] = ObjectSerializer::toHeaderValue($x_opay_headers);
        }

        // path params
        if ($id_customer !== null) {
            $resourcePath = str_replace(
                '{' . 'ID_CUSTOMER' . '}',
                ObjectSerializer::toPathValue($id_customer),
                $resourcePath
            );
        }

        // form params
        if ($account_number !== null) {
            $formParams['account_number'] = ObjectSerializer::toFormValue($account_number);
        }
        // form params
        if ($status !== null) {
            $formParams['status'] = ObjectSerializer::toFormValue($status);
        }
        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                ['application/x-www-form-urlencoded']
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }
        
        if($logger->isDebugEnabled()){
            $logger->debug('HTTP Method     :'.$method);
            $logger->debug('HTTP URL        :'.$this->config->getHost() . $resourcePath);
        }
        

        // this endpoint requires API key authentication
         list($hash, $masked_authentication_data) = AuthenticationUtil::computeHMACSHA256Hash($method, $resourcePath, $headerParams, $queryParams, $formParams, $_tempBody, $this->getConfig()->getClientSignatureKey());

        $headerParams['Authorization'] = "OPAY1-HMAC-SHA256" . " Credential=" . $this->getConfig()->getClientKey() . ",Signature=" . $hash;

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

		if($logger->isDebugEnabled()){
			$logger->debug('Request Headers  :'.json_encode($headers));
		}
		
        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return [ new Request(
            $method,
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        ), $_tempBody, $formParams, $masked_authentication_data];
    }

    /**
     * Operation retrieveCustomerAccountsPage
     *
     * Retrieve Customer Accounts Page
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp. (required)
     * @param  string $idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details. (required)
     * @param  string $requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $query_id query id of the Retrieve/Search Accounts lookup. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     * @param  string $page_size The maximum number of objects returned in the query. (optional)
     * @param  string $from_index To fetch the next set of objects that start after this object (optional)
     * @param  string $to_index To fetch the previous set of objects that end at this object (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Orbipay\PaymentsApi\Client\Model\CustomerAccountsResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function retrieveCustomerAccountsPage($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer, $query_id, $x_opay_headers = null, $page_size = null, $from_index = null, $to_index = null)
    {
         $response = $this->retrieveCustomerAccountsPageWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer, $query_id, $x_opay_headers, $page_size, $from_index, $to_index);
        return $response;
    }

    /**
     * Operation retrieveCustomerAccountsPageWithHttpInfo
     *
     * Retrieve Customer Accounts Page
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp. (required)
     * @param  string $idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details. (required)
     * @param  string $requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $query_id query id of the Retrieve/Search Accounts lookup. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     * @param  string $page_size The maximum number of objects returned in the query. (optional)
     * @param  string $from_index To fetch the next set of objects that start after this object (optional)
     * @param  string $to_index To fetch the previous set of objects that end at this object (optional)
     *
     * @throws \Orbipay\PaymentsApi\Client\ApiException on non-2xx response
     * @throws \InvalidArgumentException
     * @return array of \Orbipay\PaymentsApi\Client\Model\CustomerAccountsResponse, HTTP status code, HTTP response headers (array of strings)
     */
    public function retrieveCustomerAccountsPageWithHttpInfo($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer, $query_id, $x_opay_headers = null, $page_size = null, $from_index = null, $to_index = null)
    {
        $returnType = '\Orbipay\PaymentsApi\Client\Model\CustomerAccountsResponse';
        list($request, $_tempBody, $formParams, $masked_authentication_data) = $this->retrieveCustomerAccountsPageRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer, $query_id, $x_opay_headers, $page_size, $from_index, $to_index);
		$logger = LoggerFactory::getLogger(__CLASS__);
        try {
            $options = $this->createHttpClientOption();
            try {
             	$isTimedOut = false;
             	if($logger->isDebugEnabled()){
             		$logger->debug('Connect TimeOut :'.$options[RequestOptions::TIMEOUT]);
             		$logger->debug('Read TimeOut :'.$options[RequestOptions::TIMEOUT]);
             	}
             	$logger->info('Sending Request to Service');
                $response = $this->client->send($request, $options);
            } catch (RequestException $e) {
            	$logger->info('Receive Response from Service : HTTP Status Code :'.$e->getCode());
            	if($e instanceof ConnectException){
					$logger->warn("[{$e->getCode()}] {$e->getMessage()}");
                    $isTimedOut = true;
                }
                throw new ApiException(
                    "[{$e->getCode()}] {$e->getMessage()}",
                    $e->getCode(),
                    $e->getResponse() ? $e->getResponse()->getHeaders() : null,
                    $e->getResponse() ? $e->getResponse()->getBody()->getContents() : null, CommonUtil::get_masked_string(CommonUtil::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                ,$isTimedOut);
            }

            $statusCode = $response->getStatusCode();
			$logger->info('Receive Response from Service : HTTP Status Code :'.$statusCode);
            if ($statusCode < 200 || $statusCode > 299) {
                throw new ApiException(
                    sprintf(
                        '[%d] Error connecting to the API (%s)',
                        $statusCode,
                        $request->getUri()
                    ),
                    $statusCode,
                    $response->getHeaders(),
                    $response->getBody(), CommonUtil::get_masked_string(CommonUtil::wrapHttpRequest($request, $_tempBody, $formParams)), $masked_authentication_data
                );
            }

            $responseBody = $response->getBody();
            if ($returnType === '\SplFileObject') {
                $content = $responseBody; //stream goes to serializer
            } else {
                $content = $responseBody->getContents();
                if ($returnType !== 'string') {
                    $content = json_decode($content);
                }
            }

            return [
                ObjectSerializer::deserialize($content, $returnType, []),
                $response->getStatusCode(),
                $response->getHeaders()
            ];

        } catch (ApiException $e) {
            switch ($e->getCode()) {
                case 200:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Model\CustomerAccountsResponse',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 400:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Model\ErrorResponseVo',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 409:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Model\ErrorResponseVo',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
                case 422:
                    $data = ObjectSerializer::deserialize(
                        json_decode($e->getResponseBody()),
                        '\Orbipay\PaymentsApi\Client\Model\ErrorResponseVo',
                        $e->getResponseHeaders()
                    );
                    $e->setResponseObject($data);
                    break;
            }
            throw $e;
        }
    }


    /**
     * Create request for operation 'retrieveCustomerAccountsPage'
     *
     * @param  string $channel The channel through which the API is invoked. Please contact &lt;a href &#x3D; \&quot;mailto: support@billerpayments.com\&quot;&gt;support@billerpayments.com&lt;/a&gt; to configure channels. (required)
     * @param  string $client_key The unique identifier assigned by Orbipay to the client. (required)
     * @param  string $product The product identifier corresponding to the API. (required)
     * @param  string $timestamp The timestamp for the moment when the API call is made, in the format, &lt;b&gt;yyyy-MM-dd HH:mm:ss.SSSZ&lt;/b&gt;&lt;/br&gt; For e.g., &lt;i&gt;2018-07-13 11:41:17.422+00:00&lt;/i&gt;  Please ensure that consecutive spaces are not used in the timestamp. (required)
     * @param  string $idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \&quot;&lt;a href&#x3D;\&quot;#duplicate-requests-&amp;-retrials\&quot;&gt;Duplicate Requests &amp; Retrials&lt;/a&gt;\&quot; section for more details. (required)
     * @param  string $requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \&quot;customer\&quot;.&lt;/br&gt; If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \&quot;external_user\&quot;. It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center. (required)
     * @param  string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.&lt;/br&gt; If the requestor_type is \&quot;customer\&quot;, the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to &#39;guest&#39;.&lt;/br&gt; If the requestor_type is \&quot;external_user\&quot;, the requestor can be any unique identifier that the client may have for the external agent. (required)
     * @param  string $id_customer The unique identifier assigned by Orbipay to the customer. (required)
     * @param  string $query_id query id of the Retrieve/Search Accounts lookup. (required)
     * @param  string $x_opay_headers Intended for the future use. (optional)
     * @param  string $page_size The maximum number of objects returned in the query. (optional)
     * @param  string $from_index To fetch the next set of objects that start after this object (optional)
     * @param  string $to_index To fetch the previous set of objects that end at this object (optional)
     *
     * @throws \InvalidArgumentException
     * @return array
     */
    protected function retrieveCustomerAccountsPageRequest($channel, $client_key, $product, $timestamp, $idempotent_request_key, $requestor_type, $requestor, $id_customer, $query_id, $x_opay_headers = null, $page_size = null, $from_index = null, $to_index = null)
    {
    
     $logger = LoggerFactory::getLogger(__CLASS__);
    
        // verify the required parameter 'id_customer' is set
        if ($id_customer === null || (is_array($id_customer) && count($id_customer) === 0) || strlen($id_customer) === 0) {
     		$logger->error('Missing the required parameter $id_customer');
           throw new \InvalidArgumentException(
                 'Missing the required parameter $id_customer'
             );
        }
       
		$method = 'GET';
        $resourcePath = '/customers/{ID_CUSTOMER}/customeraccounts/lists';
        $formParams = [];
        $queryParams = [];
        $headerParams = [];
        $httpBody = '';
        $multipart = false;

        // query params
        if ($page_size !== null) {
            $queryParams['page_size'] = ObjectSerializer::toQueryValue($page_size);
        }
        // query params
        if ($query_id !== null) {
            $queryParams['query_id'] = ObjectSerializer::toQueryValue($query_id);
        }
        // query params
        if ($from_index !== null) {
            $queryParams['from_index'] = ObjectSerializer::toQueryValue($from_index);
        }
        // query params
        if ($to_index !== null) {
            $queryParams['to_index'] = ObjectSerializer::toQueryValue($to_index);
        }
        // header params
        if ($channel !== null) {
            $headerParams['channel'] = ObjectSerializer::toHeaderValue($channel);
        }
        // header params
        if ($client_key !== null) {
            $headerParams['client_key'] = ObjectSerializer::toHeaderValue($client_key);
        }
        // header params
        if ($product !== null) {
            $headerParams['product'] = ObjectSerializer::toHeaderValue($product);
        }
        // header params
        if ($timestamp !== null) {
            $headerParams['timestamp'] = ObjectSerializer::toHeaderValue($timestamp);
        }
        // header params
        if ($idempotent_request_key !== null) {
            $headerParams['idempotent_request_key'] = ObjectSerializer::toHeaderValue($idempotent_request_key);
        }
        // header params
        if ($requestor_type !== null) {
            $headerParams['requestor_type'] = ObjectSerializer::toHeaderValue($requestor_type);
        }
        // header params
        if ($requestor !== null) {
            $headerParams['requestor'] = ObjectSerializer::toHeaderValue($requestor);
        }
        // header params
        if ($x_opay_headers !== null) {
            $headerParams['X-OPAY-Headers'] = ObjectSerializer::toHeaderValue($x_opay_headers);
        }

        // path params
        if ($id_customer !== null) {
            $resourcePath = str_replace(
                '{' . 'ID_CUSTOMER' . '}',
                ObjectSerializer::toPathValue($id_customer),
                $resourcePath
            );
        }

        // body params
        $_tempBody = null;

        if ($multipart) {
            $headers = $this->headerSelector->selectHeadersForMultipart(
                ['application/json']
            );
        } else {
            $headers = $this->headerSelector->selectHeaders(
                ['application/json'],
                []
            );
        }

        // for model (json/xml)
        if (isset($_tempBody)) {
            // $_tempBody is the method argument, if present
            $httpBody = $_tempBody;
            // \stdClass has no __toString(), so we should encode it manually
            if ($httpBody instanceof \stdClass && $headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($httpBody);
            }
        } elseif (count($formParams) > 0) {
            if ($multipart) {
                $multipartContents = [];
                foreach ($formParams as $formParamName => $formParamValue) {
                    $multipartContents[] = [
                        'name' => $formParamName,
                        'contents' => $formParamValue
                    ];
                }
                // for HTTP post (form)
                $httpBody = new MultipartStream($multipartContents);

            } elseif ($headers['Content-Type'] === 'application/json') {
                $httpBody = \GuzzleHttp\json_encode($formParams);

            } else {
                // for HTTP post (form)
                $httpBody = \GuzzleHttp\Psr7\build_query($formParams);
            }
        }
        
        if($logger->isDebugEnabled()){
            $logger->debug('HTTP Method     :'.$method);
            $logger->debug('HTTP URL        :'.$this->config->getHost() . $resourcePath);
        }
        

        // this endpoint requires API key authentication
         list($hash, $masked_authentication_data) = AuthenticationUtil::computeHMACSHA256Hash($method, $resourcePath, $headerParams, $queryParams, $formParams, $_tempBody, $this->getConfig()->getClientSignatureKey());

        $headerParams['Authorization'] = "OPAY1-HMAC-SHA256" . " Credential=" . $this->getConfig()->getClientKey() . ",Signature=" . $hash;

        $defaultHeaders = [];
        if ($this->config->getUserAgent()) {
            $defaultHeaders['User-Agent'] = $this->config->getUserAgent();
        }

        $headers = array_merge(
            $defaultHeaders,
            $headerParams,
            $headers
        );

		if($logger->isDebugEnabled()){
			$logger->debug('Request Headers  :'.json_encode($headers));
		}
		
        $query = \GuzzleHttp\Psr7\build_query($queryParams);
        return [ new Request(
            $method,
            $this->config->getHost() . $resourcePath . ($query ? "?{$query}" : ''),
            $headers,
            $httpBody
        ), $_tempBody, $formParams, $masked_authentication_data];
    }

    /**
     * Create http client option
     *
     * @throws \RuntimeException on file opening failure
     * @return array of http client options
     */
    protected function createHttpClientOption()
    {
        $options = [];
        if ($this->config->getDebug()) {
            $options[RequestOptions::DEBUG] = fopen($this->config->getDebugFile(), 'a');
            if (!$options[RequestOptions::DEBUG]) {
                throw new \RuntimeException('Failed to open the debug file: ' . $this->config->getDebugFile());
            }
        }
        
        $timeoutValue = getenv("ORBIPAY_PAYMENTS_API_TIMEOUT_SECONDS");
        if (is_numeric($timeoutValue) && ((float)$timeoutValue) > 0) {
            $options[RequestOptions::TIMEOUT] = (float)$timeoutValue;
        } else {
        	$logger = LoggerFactory::getLogger(__CLASS__);
            $logger->warn('Environment Variable '."ORBIPAY_PAYMENTS_API_TIMEOUT_SECONDS".' was not set or value set is less than zero please configure it properly');
            $options[RequestOptions::TIMEOUT] = 60;
        }

        return $options;
    }
}
