<?php
/**
 * ApiException
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Orbipay REST API
 *
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.7.0
 * Contact: support@billerpayments.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.4.1-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client;

use \Exception;

/**
 * ApiException Class Doc Comment
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class ApiException extends Exception
{

	/**
     * @var string
     */
    protected $maskedHttpRequest;

    /**
     * @var string
     */
    protected $maskedAuthorizationData;

    /**
     * The HTTP body of the server response either as Json or string.
     *
     * @var mixed
     */
    protected $responseBody;

    /**
     * The HTTP header of the server response.
     *
     * @var string[]|null
     */
    protected $responseHeaders;

    /**
     * The deserialized response object
     *
     * @var $responseObject;
     */
    protected $responseObject;
    
    protected $isTimedOut;

    /**
     * @return bool
     */
    public function isTimedOut()
    {
        return $this->isTimedOut;
    }

    /**
     * Constructor
     *
     * @param string        $message         Error message
     * @param int           $code            HTTP status code
     * @param string[]|null $responseHeaders HTTP response header
     * @param mixed         $responseBody    HTTP decoded body of the server response either as \stdClass or string
     * @param string		$maskedHttpRequest
     * @param string		$maskedAuthorizationData
     */
    public function __construct($message = "", $code = 0, $responseHeaders = [], $responseBody = null, $maskedHttpRequest = null, $maskedAuthorizationData = null, $isTimedOut = false)
    {
        parent::__construct($message, $code);
        $this->responseHeaders = $responseHeaders;
        $this->responseBody = $responseBody;
        $this->maskedHttpRequest = $maskedHttpRequest;
        $this->maskedAuthorizationData = $maskedAuthorizationData;
        $this->isTimedOut = $isTimedOut;
    }

    /**
     * Gets the HTTP response header
     *
     * @return string[]|null HTTP response header
     */
    public function getResponseHeaders()
    {
        return $this->responseHeaders;
    }

    /**
     * Gets the HTTP body of the server response either as Json or string
     *
     * @return mixed HTTP body of the server response either as \stdClass or string
     */
    public function getResponseBody()
    {
        return $this->responseBody;
    }

    /**
     * Sets the deseralized response object (during deserialization)
     *
     * @param mixed $obj Deserialized response object
     *
     * @return void
     */
    public function setResponseObject($obj)
    {
        $this->responseObject = $obj;
    }

    /**
     * Gets the deseralized response object (during deserialization)
     *
     * @return mixed the deserialized response object
     */
    public function getResponseObject()
    {
        return $this->responseObject;
    }
    
     /**
     * @return null|string
     */
    public function getMaskedHttpRequest()
    {
        return $this->maskedHttpRequest;
    }

    /**
     * @param null|string $maskedHttpRequest
     */
    public function setMaskedHttpRequest($maskedHttpRequest)
    {
        $this->maskedHttpRequest = $maskedHttpRequest;
    }

    /**
     * @return null|string
     */
    public function getMaskedAuthorizationData()
    {
        return $this->maskedAuthorizationData;
    }

    /**
     * @param null|string $maskedAuthorizationData
     */
    public function setMaskedAuthorizationData($maskedAuthorizationData)
    {
        $this->maskedAuthorizationData = $maskedAuthorizationData;
    }
}
