<?php

/**
 * CreateRefundHandler
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * 
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Handlers;

use lf4php\LoggerFactory;
use Orbipay\PaymentsApi\Client\CommonUtil;
use Orbipay\PaymentsApi\Client\Configuration;
use Orbipay\PaymentsApi\Client\ApiException;
use Orbipay\PaymentsApi\Client\OrbipayApiException;
use Orbipay\PaymentsApi\Client\ObjectSerializer;
use Orbipay\PaymentsApi\Client\Wrappers\Refund;
use Orbipay\PaymentsApi\Client\Api\RefundApi;

/**
 * @internal
 */
class  CreateRefundHandler
{

 	
 
	/**
     * @param Refund $refund
     * @return Refund
     * @throws Orbipay\PaymentsApi\Client\OrbipayApiException
     */
    public function process(Refund $refund)
    {
        return $this->callAPI($refund);
    }
    
     /**
     * @param Refund $refund
     * @return Refund
     * @throws Orbipay\PaymentsApi\Client\OrbipayApiException
     */
    private function callAPI(Refund $refund)
    {
        $configuration = new Configuration();
        $configuration->setHost($refund->getApiEndPoint());
        $configuration->setClientKey($refund->getInvocationContext()->getClientKey());
        $configuration->setClientSignatureKey($refund->getInvocationContext()->getSecret());
        

        $apiInstance = new RefundApi(null, $configuration, null);
        /**
         * @var array of Orbipay\PaymentsApi\Client\Model\RefundResponse, HTTP status code, HTTP response headers (array of strings)
         */
        $response = null;
	
		 try {
		 
		 	
			
			$channel = $refund->GetInvocationContext()->GetChannel();
		 	
			
			$client_key = $refund->GetInvocationContext()->GetClientKey();
		 	
			
			$product = $refund->GetInvocationContext()->GetProduct();
		 	
			
			$timestamp = $refund->GetInvocationContext()->GetTimestamp();
			if($timestamp == null){ 
				$timestamp = CommonUtil::getTimeStamp();
			}
		 	
			
			$idempotent_request_key = $refund->GetInvocationContext()->GetIdempotentRequestKey();
		 	
			
			$requestor_type = $refund->GetInvocationContext()->GetRequestorType();
		 	
			
			$requestor = $refund->GetInvocationContext()->GetRequestor();
		 	
			
			$id_payment = $refund->GetIdPayment();
		 	
			
			$id_customer = $refund->GetIdCustomer();
		 	
			$create_refund_request = $this->populateBody($refund);
			
		 	
			
			$x_opay_headers = $refund->GetInvocationContext()->GetXOpayHeaders();
		 
		 
		    $response = $apiInstance->createRefund( $channel,  $client_key,  $product,  $timestamp,  $idempotent_request_key,  $requestor_type,  $requestor,  $id_payment,  $id_customer,  $create_refund_request,  $x_opay_headers);
		    
		} catch (GuzzleException $e) {
		    throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
		} catch (ApiException $e) {
		    throw OrbipayApiException::constructFromApiException($e);
		} catch (\Exception $e) {
		    throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
		}
		
		return $this->wrapResponse($response);

	}
	
	private function populateBody(Refund $refund)
    {

        $serializedObject=ObjectSerializer::sanitizeForSerialization($refund);

        $encodedString = json_encode($serializedObject);

		$jsonObj = json_decode($encodedString);

		

        $jsonEncode = json_encode($jsonObj);

        $requestBody = ObjectSerializer::deserialize(
            json_decode($jsonEncode),
            'Orbipay\PaymentsApi\Client\Model\CreateRefundRequest',
            null
        );
        
        return $requestBody;
    }

	/**
     * @param null $apiResponse
     * @return Refund
     */
    private function wrapResponse($apiResponse = null)
    {
    	 $wrapperResponse = null;
    	 
        if ($apiResponse === null)
            return $wrapperResponse;

        list($response, $statusCode, $headers) = $apiResponse;
        
        $logger = LoggerFactory::getLogger(__CLASS__);
        if($logger->isDebugEnabled()){
            $logger->debug('HTTP Status Code :'.$statusCode);
            $logger->debug('Response Headers  :'.json_encode($headers));
            $logger->debug('HTTP Response Body      :'.CommonUtil::get_masked_string(json_decode($response)));
        }
        
        $wrapperResponse = ObjectSerializer::deserialize(json_decode($response),'\Orbipay\PaymentsApi\Client\Wrappers\Refund',null);
        $wrapperResponse->setInvocationContext(CommonUtil::getInvocationContext($headers));
		$wrapperResponse->setHttpStatusCode($statusCode);
        return $wrapperResponse;
    }
	
}