<?php

/**
 * GetCustomerHandler
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * 
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Handlers;

use lf4php\LoggerFactory;
use Orbipay\PaymentsApi\Client\CommonUtil;
use Orbipay\PaymentsApi\Client\Configuration;
use Orbipay\PaymentsApi\Client\ApiException;
use Orbipay\PaymentsApi\Client\OrbipayApiException;
use Orbipay\PaymentsApi\Client\ObjectSerializer;
use Orbipay\PaymentsApi\Client\Wrappers\Customer;
use Orbipay\PaymentsApi\Client\Api\CustomerApi;

/**
 * @internal
 */
class  GetCustomerHandler
{

 	
 
	/**
     * @param Customer $customer
     * @return Customer
     * @throws Orbipay\PaymentsApi\Client\OrbipayApiException
     */
    public function process(Customer $customer)
    {
        return $this->callAPI($customer);
    }
    
     /**
     * @param Customer $customer
     * @return Customer
     * @throws Orbipay\PaymentsApi\Client\OrbipayApiException
     */
    private function callAPI(Customer $customer)
    {
        $configuration = new Configuration();
        $configuration->setHost($customer->getApiEndPoint());
        $configuration->setClientKey($customer->getInvocationContext()->getClientKey());
        $configuration->setClientSignatureKey($customer->getInvocationContext()->getSecret());
        

        $apiInstance = new CustomerApi(null, $configuration, null);
        /**
         * @var array of Orbipay\PaymentsApi\Client\Model\CustomerResponse, HTTP status code, HTTP response headers (array of strings)
         */
        $response = null;
	
		 try {
		 
		 	
			
			$channel = $customer->GetInvocationContext()->GetChannel();
		 	
			
			$client_key = $customer->GetInvocationContext()->GetClientKey();
		 	
			
			$product = $customer->GetInvocationContext()->GetProduct();
		 	
			
			$timestamp = $customer->GetInvocationContext()->GetTimestamp();
			if($timestamp == null){ 
				$timestamp = CommonUtil::getTimeStamp();
			}
		 	
			
			$idempotent_request_key = $customer->GetInvocationContext()->GetIdempotentRequestKey();
		 	
			
			$requestor_type = $customer->GetInvocationContext()->GetRequestorType();
		 	
			
			$requestor = $customer->GetInvocationContext()->GetRequestor();
		 	
			
			$id_customer = $customer->GetIdCustomer();
		 	
			
			$x_opay_headers = $customer->GetInvocationContext()->GetXOpayHeaders();
		 
		 
		    $response = $apiInstance->getCustomer( $channel,  $client_key,  $product,  $timestamp,  $idempotent_request_key,  $requestor_type,  $requestor,  $id_customer,  $x_opay_headers);
		    
		} catch (GuzzleException $e) {
		    throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
		} catch (ApiException $e) {
		    throw OrbipayApiException::constructFromApiException($e);
		} catch (\Exception $e) {
		    throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
		}
		
		return $this->wrapResponse($response);

	}
	

	/**
     * @param null $apiResponse
     * @return Customer
     */
    private function wrapResponse($apiResponse = null)
    {
    	 $wrapperResponse = null;
    	 
        if ($apiResponse === null)
            return $wrapperResponse;

        list($response, $statusCode, $headers) = $apiResponse;
        
        $logger = LoggerFactory::getLogger(__CLASS__);
        if($logger->isDebugEnabled()){
            $logger->debug('HTTP Status Code :'.$statusCode);
            $logger->debug('Response Headers  :'.json_encode($headers));
            $logger->debug('HTTP Response Body      :'.CommonUtil::get_masked_string(json_decode($response)));
        }
        
        $wrapperResponse = ObjectSerializer::deserialize(json_decode($response),'\Orbipay\PaymentsApi\Client\Wrappers\Customer',null);
        $wrapperResponse->setInvocationContext(CommonUtil::getInvocationContext($headers));
		$wrapperResponse->setHttpStatusCode($statusCode);
        return $wrapperResponse;
    }
	
}