<?php

/**
 * RetrieveCustomersHandler
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * 
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Handlers;

use lf4php\LoggerFactory;
use Orbipay\PaymentsApi\Client\CommonUtil;
use Orbipay\PaymentsApi\Client\Configuration;
use Orbipay\PaymentsApi\Client\ApiException;
use Orbipay\PaymentsApi\Client\OrbipayApiException;
use Orbipay\PaymentsApi\Client\ObjectSerializer;
use Orbipay\PaymentsApi\Client\Wrappers\Customers;
use Orbipay\PaymentsApi\Client\Api\CustomerApi;

/**
 * @internal
 */
class  RetrieveCustomersHandler
{

 	
 
	/**
     * @param Customers $customers
     * @return Customers
     * @throws Orbipay\PaymentsApi\Client\OrbipayApiException
     */
    public function process(Customers $customers)
    {
        return $this->callAPI($customers);
    }
    
     /**
     * @param Customers $customers
     * @return Customers
     * @throws Orbipay\PaymentsApi\Client\OrbipayApiException
     */
    private function callAPI(Customers $customers)
    {
        $configuration = new Configuration();
        $configuration->setHost($customers->getApiEndPoint());
        $configuration->setClientKey($customers->getInvocationContext()->getClientKey());
        $configuration->setClientSignatureKey($customers->getInvocationContext()->getSecret());
        

        $apiInstance = new CustomerApi(null, $configuration, null);
        /**
         * @var array of Orbipay\PaymentsApi\Client\Model\CustomersResponse, HTTP status code, HTTP response headers (array of strings)
         */
        $response = null;
	
		 try {
		 
		 	
			
			$channel = $customers->GetInvocationContext()->GetChannel();
		 	
			
			$client_key = $customers->GetInvocationContext()->GetClientKey();
		 	
			
			$product = $customers->GetInvocationContext()->GetProduct();
		 	
			
			$timestamp = $customers->GetInvocationContext()->GetTimestamp();
			if($timestamp == null){ 
				$timestamp = CommonUtil::getTimeStamp();
			}
		 	
			
			$idempotent_request_key = $customers->GetInvocationContext()->GetIdempotentRequestKey();
		 	
			
			$requestor_type = $customers->GetInvocationContext()->GetRequestorType();
		 	
			
			$requestor = $customers->GetInvocationContext()->GetRequestor();
		 	
			
			$x_opay_headers = $customers->GetInvocationContext()->GetXOpayHeaders();
		 	
			
			$page_size = $customers->GetPageSize();
		 	
			
			$customer_reference = $customers->GetCustomerReference();
		 	
			
			$ssn = $customers->GetSsn();
		 	
			
			$email = $customers->GetEmail();
		 	
			
			$account_number = $customers->GetAccountNumber();
		 
		 
		    $response = $apiInstance->retrieveCustomers( $channel,  $client_key,  $product,  $timestamp,  $idempotent_request_key,  $requestor_type,  $requestor,  $x_opay_headers,  $page_size,  $customer_reference,  $ssn,  $email,  $account_number);
		    
		} catch (GuzzleException $e) {
		    throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
		} catch (ApiException $e) {
		    throw OrbipayApiException::constructFromApiException($e);
		} catch (\Exception $e) {
		    throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
		}
		
		return $this->wrapResponse($response);

	}
	

	/**
     * @param null $apiResponse
     * @return Customers
     */
    private function wrapResponse($apiResponse = null)
    {
    	 $wrapperResponse = null;
    	 
        if ($apiResponse === null)
            return $wrapperResponse;

        list($response, $statusCode, $headers) = $apiResponse;
        
        $logger = LoggerFactory::getLogger(__CLASS__);
        if($logger->isDebugEnabled()){
            $logger->debug('HTTP Status Code :'.$statusCode);
            $logger->debug('Response Headers  :'.json_encode($headers));
            $logger->debug('HTTP Response Body      :'.CommonUtil::get_masked_string(json_decode($response)));
        }
        
        $wrapperResponse = ObjectSerializer::deserialize(json_decode($response),'\Orbipay\PaymentsApi\Client\Wrappers\Customers',null);
        $wrapperResponse->setInvocationContext(CommonUtil::getInvocationContext($headers));
		$wrapperResponse->setHttpStatusCode($statusCode);
        return $wrapperResponse;
    }
	
}