<?php

/**
 * RetrieveFundingAccountsHandler
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * 
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Handlers;

use lf4php\LoggerFactory;
use Orbipay\PaymentsApi\Client\CommonUtil;
use Orbipay\PaymentsApi\Client\Configuration;
use Orbipay\PaymentsApi\Client\ApiException;
use Orbipay\PaymentsApi\Client\OrbipayApiException;
use Orbipay\PaymentsApi\Client\ObjectSerializer;
use Orbipay\PaymentsApi\Client\Wrappers\FundingAccounts;
use Orbipay\PaymentsApi\Client\Api\FundingAccountApi;

/**
 * @internal
 */
class  RetrieveFundingAccountsHandler
{

 	
 
	/**
     * @param FundingAccounts $fundingAccounts
     * @return FundingAccounts
     * @throws Orbipay\PaymentsApi\Client\OrbipayApiException
     */
    public function process(FundingAccounts $fundingAccounts)
    {
        return $this->callAPI($fundingAccounts);
    }
    
     /**
     * @param FundingAccounts $fundingAccounts
     * @return FundingAccounts
     * @throws Orbipay\PaymentsApi\Client\OrbipayApiException
     */
    private function callAPI(FundingAccounts $fundingAccounts)
    {
        $configuration = new Configuration();
        $configuration->setHost($fundingAccounts->getApiEndPoint());
        $configuration->setClientKey($fundingAccounts->getInvocationContext()->getClientKey());
        $configuration->setClientSignatureKey($fundingAccounts->getInvocationContext()->getSecret());
        

        $apiInstance = new FundingAccountApi(null, $configuration, null);
        /**
         * @var array of Orbipay\PaymentsApi\Client\Model\FundingAccountsResponse, HTTP status code, HTTP response headers (array of strings)
         */
        $response = null;
	
		 try {
		 
		 	
			
			$channel = $fundingAccounts->GetInvocationContext()->GetChannel();
		 	
			
			$client_key = $fundingAccounts->GetInvocationContext()->GetClientKey();
		 	
			
			$product = $fundingAccounts->GetInvocationContext()->GetProduct();
		 	
			
			$timestamp = $fundingAccounts->GetInvocationContext()->GetTimestamp();
			if($timestamp == null){ 
				$timestamp = CommonUtil::getTimeStamp();
			}
		 	
			
			$idempotent_request_key = $fundingAccounts->GetInvocationContext()->GetIdempotentRequestKey();
		 	
			
			$requestor_type = $fundingAccounts->GetInvocationContext()->GetRequestorType();
		 	
			
			$requestor = $fundingAccounts->GetInvocationContext()->GetRequestor();
		 	
			
			$id_customer = $fundingAccounts->GetIdCustomer();
		 	
			
			$x_opay_headers = $fundingAccounts->GetInvocationContext()->GetXOpayHeaders();
		 	
			
			$page_size = $fundingAccounts->GetPageSize();
		 	
			
			$account_number = $fundingAccounts->GetAccountNumber();
		 	
			
			$status = $fundingAccounts->GetStatus();

		 	
			
			$aba_routing_number = $fundingAccounts->GetAbaRoutingNumber();
		 	
			
			$account_type = $fundingAccounts->GetAccountType();

		 	
			
			$account_subtype = $fundingAccounts->GetAccountSubtype();
		 
		 
		    $response = $apiInstance->retrieveFundingAccounts( $channel,  $client_key,  $product,  $timestamp,  $idempotent_request_key,  $requestor_type,  $requestor,  $id_customer,  $x_opay_headers,  $page_size,  $account_number,  $status,  $aba_routing_number,  $account_type,  $account_subtype);
		    
		} catch (GuzzleException $e) {
		    throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
		} catch (ApiException $e) {
		    throw OrbipayApiException::constructFromApiException($e);
		} catch (\Exception $e) {
		    throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
		}
		
		return $this->wrapResponse($response);

	}
	

	/**
     * @param null $apiResponse
     * @return FundingAccounts
     */
    private function wrapResponse($apiResponse = null)
    {
    	 $wrapperResponse = null;
    	 
        if ($apiResponse === null)
            return $wrapperResponse;

        list($response, $statusCode, $headers) = $apiResponse;
        
        $logger = LoggerFactory::getLogger(__CLASS__);
        if($logger->isDebugEnabled()){
            $logger->debug('HTTP Status Code :'.$statusCode);
            $logger->debug('Response Headers  :'.json_encode($headers));
            $logger->debug('HTTP Response Body      :'.CommonUtil::get_masked_string(json_decode($response)));
        }
        
        $wrapperResponse = ObjectSerializer::deserialize(json_decode($response),'\Orbipay\PaymentsApi\Client\Wrappers\FundingAccounts',null);
        $wrapperResponse->setInvocationContext(CommonUtil::getInvocationContext($headers));
		$wrapperResponse->setHttpStatusCode($statusCode);
        return $wrapperResponse;
    }
	
}