<?php

/**
 * RetrievePaymentsHandler
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * 
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Handlers;

use lf4php\LoggerFactory;
use Orbipay\PaymentsApi\Client\CommonUtil;
use Orbipay\PaymentsApi\Client\Configuration;
use Orbipay\PaymentsApi\Client\ApiException;
use Orbipay\PaymentsApi\Client\OrbipayApiException;
use Orbipay\PaymentsApi\Client\ObjectSerializer;
use Orbipay\PaymentsApi\Client\Wrappers\Payments;
use Orbipay\PaymentsApi\Client\Api\PaymentApi;

/**
 * @internal
 */
class  RetrievePaymentsHandler
{

 	
 
	/**
     * @param Payments $payments
     * @return Payments
     * @throws Orbipay\PaymentsApi\Client\OrbipayApiException
     */
    public function process(Payments $payments)
    {
        return $this->callAPI($payments);
    }
    
     /**
     * @param Payments $payments
     * @return Payments
     * @throws Orbipay\PaymentsApi\Client\OrbipayApiException
     */
    private function callAPI(Payments $payments)
    {
        $configuration = new Configuration();
        $configuration->setHost($payments->getApiEndPoint());
        $configuration->setClientKey($payments->getInvocationContext()->getClientKey());
        $configuration->setClientSignatureKey($payments->getInvocationContext()->getSecret());
        

        $apiInstance = new PaymentApi(null, $configuration, null);
        /**
         * @var array of Orbipay\PaymentsApi\Client\Model\PaymentsResponse, HTTP status code, HTTP response headers (array of strings)
         */
        $response = null;
	
		 try {
		 
		 	
			
			$channel = $payments->GetInvocationContext()->GetChannel();
		 	
			
			$client_key = $payments->GetInvocationContext()->GetClientKey();
		 	
			
			$product = $payments->GetInvocationContext()->GetProduct();
		 	
			
			$timestamp = $payments->GetInvocationContext()->GetTimestamp();
			if($timestamp == null){ 
				$timestamp = CommonUtil::getTimeStamp();
			}
		 	
			
			$idempotent_request_key = $payments->GetInvocationContext()->GetIdempotentRequestKey();
		 	
			
			$requestor_type = $payments->GetInvocationContext()->GetRequestorType();
		 	
			
			$requestor = $payments->GetInvocationContext()->GetRequestor();
		 	
			
			$x_opay_headers = $payments->GetInvocationContext()->GetXOpayHeaders();
		 	
			
			$_txn_pymnt_schld_type = $payments->GetTxnPymntSchldType();
		 	
			
			$id_customer = $payments->GetIdCustomer();
		 	
			
			$id_funding_account = $payments->GetIdFundingAccount();
		 	
			
			$id_customer_account = $payments->GetIdCustomerAccount();
		 	
			
			$confirmation_number = $payments->GetConfirmationNumber();
		 	
			
			$status = $payments->GetStatus();

		 	
			
			$payment_schedule_type = $payments->GetPaymentScheduleType();

		 	
			
			$from_date = $payments->GetFromDate();
		 	
			
			$to_date = $payments->GetToDate();
		 	
			
			$page_size = $payments->GetPageSize();
		 	
			
			$query_id = $payments->GetQueryId();
		 	
			
			$from_index = $payments->GetFromIndex();
		 	
			
			$to_index = $payments->GetToIndex();
		 
		 
		    $response = $apiInstance->retrievePayments( $channel,  $client_key,  $product,  $timestamp,  $idempotent_request_key,  $requestor_type,  $requestor,  $x_opay_headers,  $_txn_pymnt_schld_type,  $id_customer,  $id_funding_account,  $id_customer_account,  $confirmation_number,  $status,  $payment_schedule_type,  $from_date,  $to_date,  $page_size,  $query_id,  $from_index,  $to_index);
		    
		} catch (GuzzleException $e) {
		    throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
		} catch (ApiException $e) {
		    throw OrbipayApiException::constructFromApiException($e);
		} catch (\Exception $e) {
		    throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
		}
		
		return $this->wrapResponse($response);

	}
	

	/**
     * @param null $apiResponse
     * @return Payments
     */
    private function wrapResponse($apiResponse = null)
    {
    	 $wrapperResponse = null;
    	 
        if ($apiResponse === null)
            return $wrapperResponse;

        list($response, $statusCode, $headers) = $apiResponse;
        
        $logger = LoggerFactory::getLogger(__CLASS__);
        if($logger->isDebugEnabled()){
            $logger->debug('HTTP Status Code :'.$statusCode);
            $logger->debug('Response Headers  :'.json_encode($headers));
            $logger->debug('HTTP Response Body      :'.CommonUtil::get_masked_string(json_decode($response)));
        }
        
        $wrapperResponse = ObjectSerializer::deserialize(json_decode($response),'\Orbipay\PaymentsApi\Client\Wrappers\Payments',null);
        $wrapperResponse->setInvocationContext(CommonUtil::getInvocationContext($headers));
		$wrapperResponse->setHttpStatusCode($statusCode);
        return $wrapperResponse;
    }
	
}