<?php

/**
 * RetrieveRefundsHandler
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * 
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Handlers;

use lf4php\LoggerFactory;
use Orbipay\PaymentsApi\Client\CommonUtil;
use Orbipay\PaymentsApi\Client\Configuration;
use Orbipay\PaymentsApi\Client\ApiException;
use Orbipay\PaymentsApi\Client\OrbipayApiException;
use Orbipay\PaymentsApi\Client\ObjectSerializer;
use Orbipay\PaymentsApi\Client\Wrappers\Refunds;
use Orbipay\PaymentsApi\Client\Api\RefundApi;

/**
 * @internal
 */
class  RetrieveRefundsHandler
{

 	
 
	/**
     * @param Refunds $refunds
     * @return Refunds
     * @throws Orbipay\PaymentsApi\Client\OrbipayApiException
     */
    public function process(Refunds $refunds)
    {
        return $this->callAPI($refunds);
    }
    
     /**
     * @param Refunds $refunds
     * @return Refunds
     * @throws Orbipay\PaymentsApi\Client\OrbipayApiException
     */
    private function callAPI(Refunds $refunds)
    {
        $configuration = new Configuration();
        $configuration->setHost($refunds->getApiEndPoint());
        $configuration->setClientKey($refunds->getInvocationContext()->getClientKey());
        $configuration->setClientSignatureKey($refunds->getInvocationContext()->getSecret());
        

        $apiInstance = new RefundApi(null, $configuration, null);
        /**
         * @var array of Orbipay\PaymentsApi\Client\Model\RefundsResponse, HTTP status code, HTTP response headers (array of strings)
         */
        $response = null;
	
		 try {
		 
		 	
			
			$channel = $refunds->GetInvocationContext()->GetChannel();
		 	
			
			$client_key = $refunds->GetInvocationContext()->GetClientKey();
		 	
			
			$product = $refunds->GetInvocationContext()->GetProduct();
		 	
			
			$timestamp = $refunds->GetInvocationContext()->GetTimestamp();
			if($timestamp == null){ 
				$timestamp = CommonUtil::getTimeStamp();
			}
		 	
			
			$idempotent_request_key = $refunds->GetInvocationContext()->GetIdempotentRequestKey();
		 	
			
			$requestor = $refunds->GetInvocationContext()->GetRequestor();
		 	
			
			$requestor_type = $refunds->GetInvocationContext()->GetRequestorType();
		 	
			
			$x_opay_headers = $refunds->GetInvocationContext()->GetXOpayHeaders();
		 	
			
			$id_customer = $refunds->GetIdCustomer();
		 	
			
			$confirmation_number = $refunds->GetConfirmationNumber();
		 	
			
			$status = $refunds->GetStatus();

		 	
			
			$from_date = $refunds->GetFromDate();
		 	
			
			$to_date = $refunds->GetToDate();
		 	
			
			$page_size = $refunds->GetPageSize();
		 	
			
			$query_id = $refunds->GetQueryId();
		 	
			
			$from_index = $refunds->GetFromIndex();
		 	
			
			$to_index = $refunds->GetToIndex();
		 
		 
		    $response = $apiInstance->retrieveRefunds( $channel,  $client_key,  $product,  $timestamp,  $idempotent_request_key,  $requestor,  $requestor_type,  $x_opay_headers,  $id_customer,  $confirmation_number,  $status,  $from_date,  $to_date,  $page_size,  $query_id,  $from_index,  $to_index);
		    
		} catch (GuzzleException $e) {
		    throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
		} catch (ApiException $e) {
		    throw OrbipayApiException::constructFromApiException($e);
		} catch (\Exception $e) {
		    throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
		}
		
		return $this->wrapResponse($response);

	}
	

	/**
     * @param null $apiResponse
     * @return Refunds
     */
    private function wrapResponse($apiResponse = null)
    {
    	 $wrapperResponse = null;
    	 
        if ($apiResponse === null)
            return $wrapperResponse;

        list($response, $statusCode, $headers) = $apiResponse;
        
        $logger = LoggerFactory::getLogger(__CLASS__);
        if($logger->isDebugEnabled()){
            $logger->debug('HTTP Status Code :'.$statusCode);
            $logger->debug('Response Headers  :'.json_encode($headers));
            $logger->debug('HTTP Response Body      :'.CommonUtil::get_masked_string(json_decode($response)));
        }
        
        $wrapperResponse = ObjectSerializer::deserialize(json_decode($response),'\Orbipay\PaymentsApi\Client\Wrappers\Refunds',null);
        $wrapperResponse->setInvocationContext(CommonUtil::getInvocationContext($headers));
		$wrapperResponse->setHttpStatusCode($statusCode);
        return $wrapperResponse;
    }
	
}