<?php

/**
 * SimplePaymentHandler
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * 
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Handlers;

use lf4php\LoggerFactory;
use Orbipay\PaymentsApi\Client\CommonUtil;
use Orbipay\PaymentsApi\Client\Configuration;
use Orbipay\PaymentsApi\Client\ApiException;
use Orbipay\PaymentsApi\Client\OrbipayApiException;
use Orbipay\PaymentsApi\Client\ObjectSerializer;
use Orbipay\PaymentsApi\Client\Wrappers\SimplePayment;
use Orbipay\PaymentsApi\Client\Api\PaymentApi;

/**
 * @internal
 */
class  SimplePaymentHandler
{

 	
 
	/**
     * @param SimplePayment $simplePayment
     * @return SimplePayment
     * @throws Orbipay\PaymentsApi\Client\OrbipayApiException
     */
    public function process(SimplePayment $simplePayment)
    {
        return $this->callAPI($simplePayment);
    }
    
     /**
     * @param SimplePayment $simplePayment
     * @return SimplePayment
     * @throws Orbipay\PaymentsApi\Client\OrbipayApiException
     */
    private function callAPI(SimplePayment $simplePayment)
    {
        $configuration = new Configuration();
        $configuration->setHost($simplePayment->getApiEndPoint());
        $configuration->setClientKey($simplePayment->getInvocationContext()->getClientKey());
        $configuration->setClientSignatureKey($simplePayment->getInvocationContext()->getSecret());
        

        $apiInstance = new PaymentApi(null, $configuration, null);
        /**
         * @var array of Orbipay\PaymentsApi\Client\Model\SimplePaymentResponse, HTTP status code, HTTP response headers (array of strings)
         */
        $response = null;
	
		 try {
		 
		 	
			
			$channel = $simplePayment->GetInvocationContext()->GetChannel();
		 	
			
			$client_key = $simplePayment->GetInvocationContext()->GetClientKey();
		 	
			
			$product = $simplePayment->GetInvocationContext()->GetProduct();
		 	
			
			$timestamp = $simplePayment->GetInvocationContext()->GetTimestamp();
			if($timestamp == null){ 
				$timestamp = CommonUtil::getTimeStamp();
			}
		 	
			
			$idempotent_request_key = $simplePayment->GetInvocationContext()->GetIdempotentRequestKey();
		 	
			
			$requestor_type = $simplePayment->GetInvocationContext()->GetRequestorType();
		 	
			
			$requestor = $simplePayment->GetInvocationContext()->GetRequestor();
		 	
			$simple_payment_request = $this->populateBody($simplePayment);
			
		 	
			
			$x_opay_headers = $simplePayment->GetInvocationContext()->GetXOpayHeaders();
		 	
			
			$save_funding_account = $simplePayment->GetSaveFundingAccount();
		 
		 
		    $response = $apiInstance->simplePayment( $channel,  $client_key,  $product,  $timestamp,  $idempotent_request_key,  $requestor_type,  $requestor,  $simple_payment_request,  $x_opay_headers,  $save_funding_account);
		    
		} catch (GuzzleException $e) {
		    throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
		} catch (ApiException $e) {
		    throw OrbipayApiException::constructFromApiException($e);
		} catch (\Exception $e) {
		    throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
		}
		
		return $this->wrapResponse($response);

	}
	
	private function populateBody(SimplePayment $simplePayment)
    {

        $serializedObject=ObjectSerializer::sanitizeForSerialization($simplePayment);

        $encodedString = json_encode($serializedObject);

		$jsonObj = json_decode($encodedString);

		

        $jsonEncode = json_encode($jsonObj);

        $requestBody = ObjectSerializer::deserialize(
            json_decode($jsonEncode),
            'Orbipay\PaymentsApi\Client\Model\SimplePaymentRequest',
            null
        );
        
        return $requestBody;
    }

	/**
     * @param null $apiResponse
     * @return SimplePayment
     */
    private function wrapResponse($apiResponse = null)
    {
    	 $wrapperResponse = null;
    	 
        if ($apiResponse === null)
            return $wrapperResponse;

        list($response, $statusCode, $headers) = $apiResponse;
        
        $logger = LoggerFactory::getLogger(__CLASS__);
        if($logger->isDebugEnabled()){
            $logger->debug('HTTP Status Code :'.$statusCode);
            $logger->debug('Response Headers  :'.json_encode($headers));
            $logger->debug('HTTP Response Body      :'.CommonUtil::get_masked_string(json_decode($response)));
        }
        
        $wrapperResponse = ObjectSerializer::deserialize(json_decode($response),'\Orbipay\PaymentsApi\Client\Wrappers\SimplePayment',null);
        $wrapperResponse->setInvocationContext(CommonUtil::getInvocationContext($headers));
		$wrapperResponse->setHttpStatusCode($statusCode);
        return $wrapperResponse;
    }
	
}