<?php
/**
 * CreatePaymentSetupRequest
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Orbipay REST API
 *
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.7.0
 * Contact: support@billerpayments.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.4.1-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Model;

use \ArrayAccess;
use \Orbipay\PaymentsApi\Client\ObjectSerializer;

/**
 * CreatePaymentSetupRequest Class Doc Comment
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class CreatePaymentSetupRequest implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'CreatePaymentSetupRequest';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'payment_setup_reference' => 'string',
        'payment_setup_schedule_type' => 'string',
        'amount' => 'string',
        'card_cvv_number' => 'string',
        'fee' => '\Orbipay\PaymentsApi\Client\Model\FeeRequest',
        'customer' => '\Orbipay\PaymentsApi\Client\Model\CustomerMinimalRequest',
        'funding_account' => '\Orbipay\PaymentsApi\Client\Model\FundingAccountMinimalRequest',
        'customer_account' => '\Orbipay\PaymentsApi\Client\Model\CustomerAccountMinimalRequest',
        'payment_schedule' => '\Orbipay\PaymentsApi\Client\Model\PaymentScheduleVo',
        'custom_fields' => 'map[string,string]',
        'comments' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'payment_setup_reference' => null,
        'payment_setup_schedule_type' => null,
        'amount' => null,
        'card_cvv_number' => null,
        'fee' => null,
        'customer' => null,
        'funding_account' => null,
        'customer_account' => null,
        'payment_schedule' => null,
        'custom_fields' => null,
        'comments' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'payment_setup_reference' => 'payment_setup_reference',
        'payment_setup_schedule_type' => 'payment_setup_schedule_type',
        'amount' => 'amount',
        'card_cvv_number' => 'card_cvv_number',
        'fee' => 'fee',
        'customer' => 'customer',
        'funding_account' => 'funding_account',
        'customer_account' => 'customer_account',
        'payment_schedule' => 'payment_schedule',
        'custom_fields' => 'custom_fields',
        'comments' => 'comments'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'payment_setup_reference' => 'setPaymentSetupReference',
        'payment_setup_schedule_type' => 'setPaymentSetupScheduleType',
        'amount' => 'setAmount',
        'card_cvv_number' => 'setCardCvvNumber',
        'fee' => 'setFee',
        'customer' => 'setCustomer',
        'funding_account' => 'setFundingAccount',
        'customer_account' => 'setCustomerAccount',
        'payment_schedule' => 'setPaymentSchedule',
        'custom_fields' => 'setCustomFields',
        'comments' => 'setComments'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'payment_setup_reference' => 'getPaymentSetupReference',
        'payment_setup_schedule_type' => 'getPaymentSetupScheduleType',
        'amount' => 'getAmount',
        'card_cvv_number' => 'getCardCvvNumber',
        'fee' => 'getFee',
        'customer' => 'getCustomer',
        'funding_account' => 'getFundingAccount',
        'customer_account' => 'getCustomerAccount',
        'payment_schedule' => 'getPaymentSchedule',
        'custom_fields' => 'getCustomFields',
        'comments' => 'getComments'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    const PAYMENT_SETUP_SCHEDULE_TYPE_VARIABLE_RECURRING_ENROLLMENT = 'variable_recurring_enrollment';
    const PAYMENT_SETUP_SCHEDULE_TYPE_AUTOPAY_ENROLLMENT = 'autopay_enrollment';
    const PAYMENT_SETUP_SCHEDULE_TYPE_PAYMENT_PLAN = 'payment_plan';
    

    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getPaymentSetupScheduleTypeAllowableValues()
    {
        return [
            self::PAYMENT_SETUP_SCHEDULE_TYPE_VARIABLE_RECURRING_ENROLLMENT,
            self::PAYMENT_SETUP_SCHEDULE_TYPE_AUTOPAY_ENROLLMENT,
            self::PAYMENT_SETUP_SCHEDULE_TYPE_PAYMENT_PLAN,
        ];
    }
    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['payment_setup_reference'] = isset($data['payment_setup_reference']) ? $data['payment_setup_reference'] : null;
        $this->container['payment_setup_schedule_type'] = isset($data['payment_setup_schedule_type']) ? $data['payment_setup_schedule_type'] : null;
        $this->container['amount'] = isset($data['amount']) ? $data['amount'] : null;
        $this->container['card_cvv_number'] = isset($data['card_cvv_number']) ? $data['card_cvv_number'] : null;
        $this->container['fee'] = isset($data['fee']) ? $data['fee'] : null;
        $this->container['customer'] = isset($data['customer']) ? $data['customer'] : null;
        $this->container['funding_account'] = isset($data['funding_account']) ? $data['funding_account'] : null;
        $this->container['customer_account'] = isset($data['customer_account']) ? $data['customer_account'] : null;
        $this->container['payment_schedule'] = isset($data['payment_schedule']) ? $data['payment_schedule'] : null;
        $this->container['custom_fields'] = isset($data['custom_fields']) ? $data['custom_fields'] : null;
        $this->container['comments'] = isset($data['comments']) ? $data['comments'] : null;
    }


    /**
     * Gets payment_setup_reference
     *
     * @return string
     */
    public function getPaymentSetupReference()
    {
        return $this->container['payment_setup_reference'];
    }

    /**
     * Sets payment_setup_reference
     *
     * @param string $payment_setup_reference The unique identifier in the client system for the paymentSetup.
     *
     * @return $this
     */
    public function setPaymentSetupReference($payment_setup_reference)
    {
        $this->container['payment_setup_reference'] = $payment_setup_reference;

        return $this;
    }

    /**
     * Gets payment_setup_schedule_type
     *
     * @return string
     */
    public function getPaymentSetupScheduleType()
    {
        return $this->container['payment_setup_schedule_type'];
    }

    /**
     * Sets payment_setup_schedule_type
     *
     * @param string $payment_setup_schedule_type The schedule type for the payment setup.
     *
     * @return $this
     */
    public function setPaymentSetupScheduleType($payment_setup_schedule_type)
    {
        $this->container['payment_setup_schedule_type'] = $payment_setup_schedule_type;

        return $this;
    }

    /**
     * Gets amount
     *
     * @return string
     */
    public function getAmount()
    {
        return $this->container['amount'];
    }

    /**
     * Sets amount
     *
     * @param string $amount The amount being paid. In case the payment_amount_type is 'discounted_amount', 'penalty_amount' or 'other', the amount needs to be specified. In other cases, this is derived from the payment_amount_type.
     *
     * @return $this
     */
    public function setAmount($amount)
    {
        $this->container['amount'] = $amount;

        return $this;
    }

    /**
     * Gets card_cvv_number
     *
     * @return string
     */
    public function getCardCvvNumber()
    {
        return $this->container['card_cvv_number'];
    }

    /**
     * Sets card_cvv_number
     *
     * @param string $card_cvv_number This is never returned by Orbipay. This needs to be passed to Orbipay when making or editing a payment with a card funding account.
     *
     * @return $this
     */
    public function setCardCvvNumber($card_cvv_number)
    {
        $this->container['card_cvv_number'] = $card_cvv_number;

        return $this;
    }

    /**
     * Gets fee
     *
     * @return \Orbipay\PaymentsApi\Client\Model\FeeRequest
     */
    public function getFee()
    {
        return $this->container['fee'];
    }

    /**
     * Sets fee
     *
     * @param \Orbipay\PaymentsApi\Client\Model\FeeRequest $fee fee
     *
     * @return $this
     */
    public function setFee($fee)
    {
        $this->container['fee'] = $fee;

        return $this;
    }

    /**
     * Gets customer
     *
     * @return \Orbipay\PaymentsApi\Client\Model\CustomerMinimalRequest
     */
    public function getCustomer()
    {
        return $this->container['customer'];
    }

    /**
     * Sets customer
     *
     * @param \Orbipay\PaymentsApi\Client\Model\CustomerMinimalRequest $customer customer
     *
     * @return $this
     */
    public function setCustomer($customer)
    {
        $this->container['customer'] = $customer;

        return $this;
    }

    /**
     * Gets funding_account
     *
     * @return \Orbipay\PaymentsApi\Client\Model\FundingAccountMinimalRequest
     */
    public function getFundingAccount()
    {
        return $this->container['funding_account'];
    }

    /**
     * Sets funding_account
     *
     * @param \Orbipay\PaymentsApi\Client\Model\FundingAccountMinimalRequest $funding_account funding_account
     *
     * @return $this
     */
    public function setFundingAccount($funding_account)
    {
        $this->container['funding_account'] = $funding_account;

        return $this;
    }

    /**
     * Gets customer_account
     *
     * @return \Orbipay\PaymentsApi\Client\Model\CustomerAccountMinimalRequest
     */
    public function getCustomerAccount()
    {
        return $this->container['customer_account'];
    }

    /**
     * Sets customer_account
     *
     * @param \Orbipay\PaymentsApi\Client\Model\CustomerAccountMinimalRequest $customer_account customer_account
     *
     * @return $this
     */
    public function setCustomerAccount($customer_account)
    {
        $this->container['customer_account'] = $customer_account;

        return $this;
    }

    /**
     * Gets payment_schedule
     *
     * @return \Orbipay\PaymentsApi\Client\Model\PaymentScheduleVo
     */
    public function getPaymentSchedule()
    {
        return $this->container['payment_schedule'];
    }

    /**
     * Sets payment_schedule
     *
     * @param \Orbipay\PaymentsApi\Client\Model\PaymentScheduleVo $payment_schedule payment_schedule
     *
     * @return $this
     */
    public function setPaymentSchedule($payment_schedule)
    {
        $this->container['payment_schedule'] = $payment_schedule;

        return $this;
    }

    /**
     * Gets custom_fields
     *
     * @return map[string,string]
     */
    public function getCustomFields()
    {
        return $this->container['custom_fields'];
    }

    /**
     * Sets custom_fields
     *
     * @param map[string,string] $custom_fields The additional information or meta-information that Orbipay can accept, maintain and transmit back to the client. The custom fields need to be configured with Orbipay before they can be accepted. Orbipay would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields. Only the custom fields enabled for the client, in Orbipay, would be accepted in the requests.
     *
     * @return $this
     */
    public function setCustomFields($custom_fields)
    {
        $this->container['custom_fields'] = $custom_fields;

        return $this;
    }

    /**
     * Gets comments
     *
     * @return string
     */
    public function getComments()
    {
        return $this->container['comments'];
    }

    /**
     * Sets comments
     *
     * @param string $comments Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (Orbipay) is not responsible for the security of any sensitive information that may be passed as part of the memo.
     *
     * @return $this
     */
    public function setComments($comments)
    {
        $this->container['comments'] = $comments;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


