<?php
/**
 * RefundResponse
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

/**
 * Orbipay REST API
 *
 * The Payments API enables businesses to accept credit, debit, and bank account payments.
 *
 * OpenAPI spec version: 1.7.0
 * Contact: support@billerpayments.com
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 2.4.1-SNAPSHOT
 */

/**
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Model;

use \ArrayAccess;
use \Orbipay\PaymentsApi\Client\ObjectSerializer;

/**
 * RefundResponse Class Doc Comment
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */
class RefundResponse implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'RefundResponse';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'refund_reference' => 'string',
        'id' => 'string',
        'url' => 'string',
        'refund_type' => 'string',
        'refund_amount' => 'string',
        'fee_refund' => '\Orbipay\PaymentsApi\Client\Model\FeeRefundResponse',
        'status' => 'string',
        'confirmation_number' => 'string',
        'refund_date' => 'string',
        'refund_entry_date' => 'string',
        'expected_refund_settlement_date' => 'string',
        'custom_fields' => 'map[string,string]',
        'comments' => 'string',
        'source_payment' => '\Orbipay\PaymentsApi\Client\Model\SourcePayment',
        'payment_network_response' => '\Orbipay\PaymentsApi\Client\Model\PaymentNetworkResponseVo',
        'audit_info' => '\Orbipay\PaymentsApi\Client\Model\AuditInfoVo'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'refund_reference' => null,
        'id' => null,
        'url' => null,
        'refund_type' => null,
        'refund_amount' => null,
        'fee_refund' => null,
        'status' => null,
        'confirmation_number' => null,
        'refund_date' => null,
        'refund_entry_date' => null,
        'expected_refund_settlement_date' => null,
        'custom_fields' => null,
        'comments' => null,
        'source_payment' => null,
        'payment_network_response' => null,
        'audit_info' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'refund_reference' => 'refund_reference',
        'id' => 'id',
        'url' => 'url',
        'refund_type' => 'refund_type',
        'refund_amount' => 'refund_amount',
        'fee_refund' => 'fee_refund',
        'status' => 'status',
        'confirmation_number' => 'confirmation_number',
        'refund_date' => 'refund_date',
        'refund_entry_date' => 'refund_entry_date',
        'expected_refund_settlement_date' => 'expected_refund_settlement_date',
        'custom_fields' => 'custom_fields',
        'comments' => 'comments',
        'source_payment' => 'source_payment',
        'payment_network_response' => 'payment_network_response',
        'audit_info' => 'audit_info'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'refund_reference' => 'setRefundReference',
        'id' => 'setId',
        'url' => 'setUrl',
        'refund_type' => 'setRefundType',
        'refund_amount' => 'setRefundAmount',
        'fee_refund' => 'setFeeRefund',
        'status' => 'setStatus',
        'confirmation_number' => 'setConfirmationNumber',
        'refund_date' => 'setRefundDate',
        'refund_entry_date' => 'setRefundEntryDate',
        'expected_refund_settlement_date' => 'setExpectedRefundSettlementDate',
        'custom_fields' => 'setCustomFields',
        'comments' => 'setComments',
        'source_payment' => 'setSourcePayment',
        'payment_network_response' => 'setPaymentNetworkResponse',
        'audit_info' => 'setAuditInfo'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'refund_reference' => 'getRefundReference',
        'id' => 'getId',
        'url' => 'getUrl',
        'refund_type' => 'getRefundType',
        'refund_amount' => 'getRefundAmount',
        'fee_refund' => 'getFeeRefund',
        'status' => 'getStatus',
        'confirmation_number' => 'getConfirmationNumber',
        'refund_date' => 'getRefundDate',
        'refund_entry_date' => 'getRefundEntryDate',
        'expected_refund_settlement_date' => 'getExpectedRefundSettlementDate',
        'custom_fields' => 'getCustomFields',
        'comments' => 'getComments',
        'source_payment' => 'getSourcePayment',
        'payment_network_response' => 'getPaymentNetworkResponse',
        'audit_info' => 'getAuditInfo'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$swaggerModelName;
    }

    const REFUND_TYPE_PAYMENT_AND_FEE = 'payment_and_fee';
    const REFUND_TYPE_PAYMENT_ONLY = 'payment_only';
    const REFUND_TYPE_FEE_ONLY = 'fee_only';
    const REFUND_TYPE_OTHER = 'other';
    const STATUS_SCHEDULED = 'scheduled';
    const STATUS_CANCELLED = 'cancelled';
    const STATUS_PROCESSING = 'processing';
    const STATUS_PROCESSED = 'processed';
    const STATUS_DECLINED = 'declined';
    const STATUS_RETURNED = 'returned';
    

    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getRefundTypeAllowableValues()
    {
        return [
            self::REFUND_TYPE_PAYMENT_AND_FEE,
            self::REFUND_TYPE_PAYMENT_ONLY,
            self::REFUND_TYPE_FEE_ONLY,
            self::REFUND_TYPE_OTHER,
        ];
    }
    
    /**
     * Gets allowable values of the enum
     *
     * @return string[]
     */
    public function getStatusAllowableValues()
    {
        return [
            self::STATUS_SCHEDULED,
            self::STATUS_CANCELLED,
            self::STATUS_PROCESSING,
            self::STATUS_PROCESSED,
            self::STATUS_DECLINED,
            self::STATUS_RETURNED,
        ];
    }
    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->container['refund_reference'] = isset($data['refund_reference']) ? $data['refund_reference'] : null;
        $this->container['id'] = isset($data['id']) ? $data['id'] : null;
        $this->container['url'] = isset($data['url']) ? $data['url'] : null;
        $this->container['refund_type'] = isset($data['refund_type']) ? $data['refund_type'] : null;
        $this->container['refund_amount'] = isset($data['refund_amount']) ? $data['refund_amount'] : null;
        $this->container['fee_refund'] = isset($data['fee_refund']) ? $data['fee_refund'] : null;
        $this->container['status'] = isset($data['status']) ? $data['status'] : null;
        $this->container['confirmation_number'] = isset($data['confirmation_number']) ? $data['confirmation_number'] : null;
        $this->container['refund_date'] = isset($data['refund_date']) ? $data['refund_date'] : null;
        $this->container['refund_entry_date'] = isset($data['refund_entry_date']) ? $data['refund_entry_date'] : null;
        $this->container['expected_refund_settlement_date'] = isset($data['expected_refund_settlement_date']) ? $data['expected_refund_settlement_date'] : null;
        $this->container['custom_fields'] = isset($data['custom_fields']) ? $data['custom_fields'] : null;
        $this->container['comments'] = isset($data['comments']) ? $data['comments'] : null;
        $this->container['source_payment'] = isset($data['source_payment']) ? $data['source_payment'] : null;
        $this->container['payment_network_response'] = isset($data['payment_network_response']) ? $data['payment_network_response'] : null;
        $this->container['audit_info'] = isset($data['audit_info']) ? $data['audit_info'] : null;
    }


    /**
     * Gets refund_reference
     *
     * @return string
     */
    public function getRefundReference()
    {
        return $this->container['refund_reference'];
    }

    /**
     * Sets refund_reference
     *
     * @param string $refund_reference The unique identifier in the client system for the refund.
     *
     * @return $this
     */
    public function setRefundReference($refund_reference)
    {
        $this->container['refund_reference'] = $refund_reference;

        return $this;
    }

    /**
     * Gets id
     *
     * @return string
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param string $id The unique identifier assigned by Orbipay to the refund.
     *
     * @return $this
     */
    public function setId($id)
    {
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets url
     *
     * @return string
     */
    public function getUrl()
    {
        return $this->container['url'];
    }

    /**
     * Sets url
     *
     * @param string $url This URL fetches the details of refund.
     *
     * @return $this
     */
    public function setUrl($url)
    {
        $this->container['url'] = $url;

        return $this;
    }

    /**
     * Gets refund_type
     *
     * @return string
     */
    public function getRefundType()
    {
        return $this->container['refund_type'];
    }

    /**
     * Sets refund_type
     *
     * @param string $refund_type The portion of the payment amount that is to be or has been refunded. The original payment can be refunded fully including the amount and the fee components, or partially, for just the amount or the fee component. Refund can also be initiated for an arbitrary amount limited by the original payment amount.
     *
     * @return $this
     */
    public function setRefundType($refund_type)
    {
        $this->container['refund_type'] = $refund_type;

        return $this;
    }

    /**
     * Gets refund_amount
     *
     * @return string
     */
    public function getRefundAmount()
    {
        return $this->container['refund_amount'];
    }

    /**
     * Sets refund_amount
     *
     * @param string $refund_amount The refund amount upto 2 decimal places.
     *
     * @return $this
     */
    public function setRefundAmount($refund_amount)
    {
        $this->container['refund_amount'] = $refund_amount;

        return $this;
    }

    /**
     * Gets fee_refund
     *
     * @return \Orbipay\PaymentsApi\Client\Model\FeeRefundResponse
     */
    public function getFeeRefund()
    {
        return $this->container['fee_refund'];
    }

    /**
     * Sets fee_refund
     *
     * @param \Orbipay\PaymentsApi\Client\Model\FeeRefundResponse $fee_refund fee_refund
     *
     * @return $this
     */
    public function setFeeRefund($fee_refund)
    {
        $this->container['fee_refund'] = $fee_refund;

        return $this;
    }

    /**
     * Gets status
     *
     * @return string
     */
    public function getStatus()
    {
        return $this->container['status'];
    }

    /**
     * Sets status
     *
     * @param string $status The status of the refund.
     *
     * @return $this
     */
    public function setStatus($status)
    {
        $this->container['status'] = $status;

        return $this;
    }

    /**
     * Gets confirmation_number
     *
     * @return string
     */
    public function getConfirmationNumber()
    {
        return $this->container['confirmation_number'];
    }

    /**
     * Sets confirmation_number
     *
     * @param string $confirmation_number The confirmation number or reference provided to the customer for the refund.
     *
     * @return $this
     */
    public function setConfirmationNumber($confirmation_number)
    {
        $this->container['confirmation_number'] = $confirmation_number;

        return $this;
    }

    /**
     * Gets refund_date
     *
     * @return string
     */
    public function getRefundDate()
    {
        return $this->container['refund_date'];
    }

    /**
     * Sets refund_date
     *
     * @param string $refund_date The date on which the refund is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     *
     * @return $this
     */
    public function setRefundDate($refund_date)
    {
        $this->container['refund_date'] = $refund_date;

        return $this;
    }

    /**
     * Gets refund_entry_date
     *
     * @return string
     */
    public function getRefundEntryDate()
    {
        return $this->container['refund_entry_date'];
    }

    /**
     * Sets refund_entry_date
     *
     * @param string $refund_entry_date The date on which the refund captured in Orbipay. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     *
     * @return $this
     */
    public function setRefundEntryDate($refund_entry_date)
    {
        $this->container['refund_entry_date'] = $refund_entry_date;

        return $this;
    }

    /**
     * Gets expected_refund_settlement_date
     *
     * @return string
     */
    public function getExpectedRefundSettlementDate()
    {
        return $this->container['expected_refund_settlement_date'];
    }

    /**
     * Sets expected_refund_settlement_date
     *
     * @param string $expected_refund_settlement_date The date by which the credits would be posted to the original funding account. ISO8601 full-date format, YYYY-MM-DD
     *
     * @return $this
     */
    public function setExpectedRefundSettlementDate($expected_refund_settlement_date)
    {
        $this->container['expected_refund_settlement_date'] = $expected_refund_settlement_date;

        return $this;
    }

    /**
     * Gets custom_fields
     *
     * @return map[string,string]
     */
    public function getCustomFields()
    {
        return $this->container['custom_fields'];
    }

    /**
     * Sets custom_fields
     *
     * @param map[string,string] $custom_fields The additional information or meta-information that Orbipay can accept, maintain and transmit back to the client. The custom fields need to be configured with Orbipay before they can be accepted. Orbipay would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields.
     *
     * @return $this
     */
    public function setCustomFields($custom_fields)
    {
        $this->container['custom_fields'] = $custom_fields;

        return $this;
    }

    /**
     * Gets comments
     *
     * @return string
     */
    public function getComments()
    {
        return $this->container['comments'];
    }

    /**
     * Sets comments
     *
     * @param string $comments Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (Orbipay) is not responsible for the security of any sensitive information that may be passed as part of the memo.
     *
     * @return $this
     */
    public function setComments($comments)
    {
        $this->container['comments'] = $comments;

        return $this;
    }

    /**
     * Gets source_payment
     *
     * @return \Orbipay\PaymentsApi\Client\Model\SourcePayment
     */
    public function getSourcePayment()
    {
        return $this->container['source_payment'];
    }

    /**
     * Sets source_payment
     *
     * @param \Orbipay\PaymentsApi\Client\Model\SourcePayment $source_payment source_payment
     *
     * @return $this
     */
    public function setSourcePayment($source_payment)
    {
        $this->container['source_payment'] = $source_payment;

        return $this;
    }

    /**
     * Gets payment_network_response
     *
     * @return \Orbipay\PaymentsApi\Client\Model\PaymentNetworkResponseVo
     */
    public function getPaymentNetworkResponse()
    {
        return $this->container['payment_network_response'];
    }

    /**
     * Sets payment_network_response
     *
     * @param \Orbipay\PaymentsApi\Client\Model\PaymentNetworkResponseVo $payment_network_response payment_network_response
     *
     * @return $this
     */
    public function setPaymentNetworkResponse($payment_network_response)
    {
        $this->container['payment_network_response'] = $payment_network_response;

        return $this;
    }

    /**
     * Gets audit_info
     *
     * @return \Orbipay\PaymentsApi\Client\Model\AuditInfoVo
     */
    public function getAuditInfo()
    {
        return $this->container['audit_info'];
    }

    /**
     * Sets audit_info
     *
     * @param \Orbipay\PaymentsApi\Client\Model\AuditInfoVo $audit_info audit_info
     *
     * @return $this
     */
    public function setAuditInfo($audit_info)
    {
        $this->container['audit_info'] = $audit_info;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset)
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset)
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value)
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset)
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        if (defined('JSON_PRETTY_PRINT')) { // use JSON pretty print
            return json_encode(
                ObjectSerializer::sanitizeForSerialization($this),
                JSON_PRETTY_PRINT
            );
        }

        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }
}


