<?php

/**
 * CustomerAccount
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 */

/**
 * 
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 
 */


/**
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Wrappers;

use \Orbipay\PaymentsApi\Client\ObjectSerializer;
use \Orbipay\PaymentsApi\Client\MultiMap;
use \Orbipay\PaymentsApi\Client\CommonUtil;
use Orbipay\PaymentsApi\Client\OrbipayApiException;
use lf4php\LoggerFactory;


/**
 * CustomerAccount Class Doc Comment
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 */
class CustomerAccount  extends Base 
{

	const DISCRIMINATOR = null;
    
        /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'account_holder_name' => 'string', 
        'nickname' => 'string', 
        'address' => '\Orbipay\PaymentsApi\Client\Wrappers\Address', 
        'customer_account_reference' => 'string', 
        'account_number' => 'string', 
        'current_balance' => 'string', 
        'current_statement_balance' => 'string', 
        'minimum_payment_due' => 'string', 
        'past_amount_due' => 'string', 
        'payment_due_date' => 'string', 
        'statement_date' => 'string', 
        'id' => 'string', 
        'url' => 'string', 
        'status' => 'string', 
        'custom_fields' => 'map[string,string]', 
        'comments' => 'string', 
        'audit_info' => '\Orbipay\PaymentsApi\Client\Wrappers\AuditInfo', 
        'id_customer_account' => 'string', 
        'id_customer' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'account_holder_name' => null,
        'nickname' => null,
        'address' => null,
        'customer_account_reference' => null,
        'account_number' => null,
        'current_balance' => null,
        'current_statement_balance' => null,
        'minimum_payment_due' => null,
        'past_amount_due' => null,
        'payment_due_date' => null,
        'statement_date' => null,
        'id' => null,
        'url' => null,
        'status' => null,
        'custom_fields' => null,
        'comments' => null,
        'audit_info' => null,
        'id_customer_account' => null,
        'id_customer' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'account_holder_name' => 'account_holder_name',
        'nickname' => 'nickname',
        'address' => 'address',
        'customer_account_reference' => 'customer_account_reference',
        'account_number' => 'account_number',
        'current_balance' => 'current_balance',
        'current_statement_balance' => 'current_statement_balance',
        'minimum_payment_due' => 'minimum_payment_due',
        'past_amount_due' => 'past_amount_due',
        'payment_due_date' => 'payment_due_date',
        'statement_date' => 'statement_date',
        'id' => 'id',
        'url' => 'url',
        'status' => 'status',
        'custom_fields' => 'custom_fields',
        'comments' => 'comments',
        'audit_info' => 'audit_info',
        'id_customer_account' => 'ID_CUSTOMER_ACCOUNT',
        'id_customer' => 'ID_CUSTOMER'
    ];
    
     /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'account_holder_name' => 'setAccountHolderName',
        'nickname' => 'setNickname',
        'address' => 'setAddress',
        'customer_account_reference' => 'setCustomerAccountReference',
        'account_number' => 'setAccountNumber',
        'current_balance' => 'setCurrentBalance',
        'current_statement_balance' => 'setCurrentStatementBalance',
        'minimum_payment_due' => 'setMinimumPaymentDue',
        'past_amount_due' => 'setPastAmountDue',
        'payment_due_date' => 'setPaymentDueDate',
        'statement_date' => 'setStatementDate',
        'id' => 'setId',
        'url' => 'setUrl',
        'status' => 'setStatus',
        'custom_fields' => 'setCustomFields',
        'comments' => 'setComments',
        'audit_info' => 'setAuditInfo',
        'id_customer_account' => 'setIdCustomerAccount',
        'id_customer' => 'setIdCustomer'
    ];
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'account_holder_name' => 'getAccountHolderName',
        'nickname' => 'getNickname',
        'address' => 'getAddress',
        'customer_account_reference' => 'getCustomerAccountReference',
        'account_number' => 'getAccountNumber',
        'current_balance' => 'getCurrentBalance',
        'current_statement_balance' => 'getCurrentStatementBalance',
        'minimum_payment_due' => 'getMinimumPaymentDue',
        'past_amount_due' => 'getPastAmountDue',
        'payment_due_date' => 'getPaymentDueDate',
        'statement_date' => 'getStatementDate',
        'id' => 'getId',
        'url' => 'getUrl',
        'status' => 'getStatus',
        'custom_fields' => 'getCustomFields',
        'comments' => 'getComments',
        'audit_info' => 'getAuditInfo',
        'id_customer_account' => 'getIdCustomerAccount',
        'id_customer' => 'getIdCustomer'
    ];
    
      /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }
    

    /**
     * @internal
     * Sets account_holder_name
     * @param string $account_holder_name The name as specified on the account.
     * @return $this
     */
    public function setAccountHolderName($account_holder_name)
    {
        $this->account_holder_name = $account_holder_name;

        return $this;
    }

    /**
     * @internal
     * Sets nickname
     * @param string $nickname The nickname by which a customer might want to identify the account.
     * @return $this
     */
    public function setNickname($nickname)
    {
        $this->nickname = $nickname;

        return $this;
    }

    /**
     * @internal
     * Sets address
     * @param \Orbipay\PaymentsApi\Client\Wrappers\Address $address address
     * @return $this
     */
    public function setAddress($address)
    {
        $this->address = $address;

        return $this;
    }

    /**
     * @internal
     * Sets customer_account_reference
     * @param string $customer_account_reference The unique identifier in the client system for the customer account.
     * @return $this
     */
    public function setCustomerAccountReference($customer_account_reference)
    {
        $this->customer_account_reference = $customer_account_reference;

        return $this;
    }

    /**
     * @internal
     * Sets account_number
     * @param string $account_number The number or reference that a customer uses to identify the customer's account.
     * @return $this
     */
    public function setAccountNumber($account_number)
    {
        $this->account_number = $account_number;

        return $this;
    }

    /**
     * @internal
     * Sets current_balance
     * @param string $current_balance The current balance on the customer's account with the biller.
     * @return $this
     */
    public function setCurrentBalance($current_balance)
    {
        $this->current_balance = $current_balance;

        return $this;
    }

    /**
     * @internal
     * Sets current_statement_balance
     * @param string $current_statement_balance The balance on the customer’s account with the biller as reported on the last statement.
     * @return $this
     */
    public function setCurrentStatementBalance($current_statement_balance)
    {
        $this->current_statement_balance = $current_statement_balance;

        return $this;
    }

    /**
     * @internal
     * Sets minimum_payment_due
     * @param string $minimum_payment_due The minimum payment amount, as specified by the biller, that needs to be made against the customer’s account.
     * @return $this
     */
    public function setMinimumPaymentDue($minimum_payment_due)
    {
        $this->minimum_payment_due = $minimum_payment_due;

        return $this;
    }

    /**
     * @internal
     * Sets past_amount_due
     * @param string $past_amount_due The amount that is due from the past bills/statements on the customer’s account with the biller.
     * @return $this
     */
    public function setPastAmountDue($past_amount_due)
    {
        $this->past_amount_due = $past_amount_due;

        return $this;
    }

    /**
     * @internal
     * Sets payment_due_date
     * @param string $payment_due_date The date by which the customer needs to clear the dues against the customer's account with the biller. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     * @return $this
     */
    public function setPaymentDueDate($payment_due_date)
    {
        $this->payment_due_date = $payment_due_date;

        return $this;
    }

    /**
     * @internal
     * Sets statement_date
     * @param string $statement_date The date on which the biller generates the statement for the customer's account. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     * @return $this
     */
    public function setStatementDate($statement_date)
    {
        $this->statement_date = $statement_date;

        return $this;
    }

    /**
     * @internal
     * Sets id
     * @param string $id Id is a unique identifier assigned to the customer account in Orbipay.
     * @return $this
     */
    public function setId($id)
    {
        $this->id = $id;

        return $this;
    }

    /**
     * @internal
     * Sets url
     * @param string $url This URL fetches the Account details.
     * @return $this
     */
    public function setUrl($url)
    {
        $this->url = $url;

        return $this;
    }

    /**
     * @internal
     * Sets status
     * @param string $status The status of the customer's account in Orbipay.
     * @return $this
     */
    public function setStatus($status)
    {
        $this->status = $status;

        return $this;
    }

    /**
     * @internal
     * Sets custom_fields
     * @param map[string,string] $custom_fields The additional information or meta-information that Orbipay can accept, maintain and transmit back to the client. The custom fields need to be configured with Orbipay before they can be accepted. Orbipay would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields. Only the custom fields enabled for the client, in Orbipay, would be accepted in the requests.
     * @return $this
     */
    public function setCustomFields($custom_fields)
    {
        $this->custom_fields = $custom_fields;

        return $this;
    }

    /**
     * @internal
     * Sets comments
     * @param string $comments Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (Orbipay) is not responsible for the security of any sensitive information that may be passed as part of the memo.
     * @return $this
     */
    public function setComments($comments)
    {
        $this->comments = $comments;

        return $this;
    }

    /**
     * @internal
     * Sets audit_info
     * @param \Orbipay\PaymentsApi\Client\Wrappers\AuditInfo $audit_info audit_info
     * @return $this
     */
    public function setAuditInfo($audit_info)
    {
        $this->audit_info = $audit_info;

        return $this;
    }

    /**
     * @internal
     * Sets id_customer_account
     * @param string $id_customer_account The unique identifier assigned by Orbipay to the Customer Account.
     * @return $this
     */
    public function setIdCustomerAccount($id_customer_account)
    {
        $this->id_customer_account = $id_customer_account;

        return $this;
    }

    /**
     * @internal
     * Sets id_customer
     * @param string $id_customer The unique identifier assigned by Orbipay to the customer.
     * @return $this
     */
    public function setIdCustomer($id_customer)
    {
        $this->id_customer = $id_customer;

        return $this;
    }


    private $account_holder_name;
  
    public function getAccountHolderName()
    {
        return $this->account_holder_name;
    }

    private $nickname;
  
    public function getNickname()
    {
        return $this->nickname;
    }

    private $address;
  
    public function getAddress()
    {
        return $this->address;
    }

    private $customer_account_reference;
  
    public function getCustomerAccountReference()
    {
        return $this->customer_account_reference;
    }

    private $account_number;
  
    public function getAccountNumber()
    {
        return $this->account_number;
    }

    private $current_balance;
  
    public function getCurrentBalance()
    {
        return $this->current_balance;
    }

    private $current_statement_balance;
  
    public function getCurrentStatementBalance()
    {
        return $this->current_statement_balance;
    }

    private $minimum_payment_due;
  
    public function getMinimumPaymentDue()
    {
        return $this->minimum_payment_due;
    }

    private $past_amount_due;
  
    public function getPastAmountDue()
    {
        return $this->past_amount_due;
    }

    private $payment_due_date;
  
    public function getPaymentDueDate()
    {
        return $this->payment_due_date;
    }

    private $statement_date;
  
    public function getStatementDate()
    {
        return $this->statement_date;
    }

    private $id;
  
    public function getId()
    {
        return $this->id;
    }

    private $url;
  
    public function getUrl()
    {
        return $this->url;
    }

    private $status;

    public function getStatus()
    {
        return $this->status;
    }
    

    private $custom_fields;
  
    public function getCustomFields()
    {
        return $this->custom_fields;
    }

    private $comments;
  
    public function getComments()
    {
        return $this->comments;
    }

    private $audit_info;
  
    public function getAuditInfo()
    {
        return $this->audit_info;
    }

    private $id_customer_account;
  
    public function getIdCustomerAccount()
    {
        return $this->id_customer_account;
    }

    private $id_customer;
  
    public function getIdCustomer()
    {
        return $this->id_customer;
    }

    
     /**
     * CustomerAccount constructor.
     * @param string $id_customer_account 
     */
    public function __construct($id_customer_account = null)
    {
        $this->id_customer_account = $id_customer_account;
		$this->id = $id_customer_account;
    }
       
    public function forClient($client_key = null)
    {
		parent::forClient($client_key);
        
        return $this; 
    }
    public function videChannel($channel = null)
    {
		parent::videChannel($channel);
        
        return $this; 
    }
    public function withDetails($account_holder_name = null, $nickname = null, $account_number = null, $minimum_payment_due = null, $past_amount_due = null, $payment_due_date = null, $statement_date = null)
    {
        			$this->account_holder_name = $account_holder_name;
        		
        

        			$this->nickname = $nickname;
        		
        

        			$this->account_number = $account_number;
        		
        

        			$this->minimum_payment_due = $minimum_payment_due;
        		
        

        			$this->past_amount_due = $past_amount_due;
        		
        

        			$this->payment_due_date = $payment_due_date;
        		
        

        			$this->statement_date = $statement_date;
        		
        

        
        return $this; 
    }
    public function withBalances($current_balance = null, $current_statement_balance = null)
    {
        			$this->current_balance = $current_balance;
        		
        

        			$this->current_statement_balance = $current_statement_balance;
        		
        

        
        return $this; 
    }
    public function withReference($customer_account_reference = null)
    {
        			$this->customer_account_reference = $customer_account_reference;
        		
        

        
        return $this; 
    }
    public function withStatus($status = null)
    {
        			$this->status = $status;
        		
        

        
        return $this; 
    }
    public function withAddress($address = null)
    {
        			$this->address = $address;
        		
        

        
        return $this; 
    }
    public function withCustomFields($custom_fields = null)
    {
				if(isset($custom_fields)){
					if(count($custom_fields) == 0){
						$this->custom_fields = null;
					}
					else{
        				$this->custom_fields = $custom_fields;
					}
        		}else{
        			$this->custom_fields = $custom_fields;
        		}
        		
        

        
        return $this; 
    }
    public function withMemo($comments = null)
    {
        			$this->comments = $comments;
        		
        

        
        return $this; 
    }
    public function forCustomer($id_customer = null)
    {
        			$this->id_customer = $id_customer;
        		
        

        
        return $this; 
    }
    
    public function renewedBy($requestor = null , $requestor_type = null )
    {
       $this->requestedBy( $requestor, $requestor_type);
       return $this;
    }

    public function retrievedBy($requestor = null , $requestor_type = null )
    {
       $this->requestedBy( $requestor, $requestor_type);
       return $this;
    }

    
    public function renew(InvocationContext $invocationContext, $liveMode = null,  $apiEndPoint = null)
    {
     	try {
	    	$this->withContext($invocationContext, $liveMode, $apiEndPoint);
	    	$handler = new  \Orbipay\PaymentsApi\Client\Handlers\RenewCustomerAccountHandler();
	        return $handler->process($this);
		} catch (OrbipayApiException $e) {
            throw $e;
        } catch (\Exception $e) {
             $logger = LoggerFactory::getLogger(__CLASS__);
             $logger->error($e->getMessage());
            throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
        }
    }
    public function get(InvocationContext $invocationContext, $liveMode = null,  $apiEndPoint = null)
    {
     	try {
	    	$this->withContext($invocationContext, $liveMode, $apiEndPoint);
	    	$handler = new  \Orbipay\PaymentsApi\Client\Handlers\RetrieveCustomerAccountHandler();
	        return $handler->process($this);
		} catch (OrbipayApiException $e) {
            throw $e;
        } catch (\Exception $e) {
             $logger = LoggerFactory::getLogger(__CLASS__);
             $logger->error($e->getMessage());
            throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
        }
    }
    
    
	/**
     * Specify data which should be serialized to JSON
     * @link http://php.net/manual/en/jsonserializable.jsonserialize.php
     * @return mixed data which can be serialized by <b>json_encode</b>,
     * which is a value of any type other than a resource.
     * @since 5.4.0
     */
    public function jsonSerialize()
    {
        return CommonUtil::json_serialize(get_object_vars($this) , parent::jsonSerialize());
    }
}


