<?php

/**
 * Fee
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 */

/**
 * 
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 
 */


/**
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Wrappers;

use \Orbipay\PaymentsApi\Client\ObjectSerializer;
use \Orbipay\PaymentsApi\Client\MultiMap;
use \Orbipay\PaymentsApi\Client\CommonUtil;
use Orbipay\PaymentsApi\Client\OrbipayApiException;
use lf4php\LoggerFactory;


/**
 * Fee Class Doc Comment
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 */
class Fee  
{

	const DISCRIMINATOR = null;
    
        /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'fee_type' => 'string', 
        'fee_amount' => 'string', 
        'id' => 'string', 
        'url' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'fee_type' => null,
        'fee_amount' => null,
        'id' => null,
        'url' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'fee_type' => 'fee_type',
        'fee_amount' => 'fee_amount',
        'id' => 'id',
        'url' => 'url'
    ];
    
     /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'fee_type' => 'setFeeType',
        'fee_amount' => 'setFeeAmount',
        'id' => 'setId',
        'url' => 'setUrl'
    ];
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'fee_type' => 'getFeeType',
        'fee_amount' => 'getFeeAmount',
        'id' => 'getId',
        'url' => 'getUrl'
    ];
    
      /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }
    

    /**
     * @internal
     * Sets fee_type
     * @param string $fee_type The way the fee is being charged to the customer. Fee could be added to the amount being paid, or, it could be charged separately by the biller. The fee_type would default to add_to_principal if the fee is not configured for the client in Orbipay.
     * @return $this
     */
    public function setFeeType($fee_type)
    {
        $this->fee_type = $fee_type;

        return $this;
    }

    /**
     * @internal
     * Sets fee_amount
     * @param string $fee_amount The fee amount upto 2 decimal places.
     * @return $this
     */
    public function setFeeAmount($fee_amount)
    {
        $this->fee_amount = $fee_amount;

        return $this;
    }

    /**
     * @internal
     * Sets id
     * @param string $id The unique identifier assigned by Orbipay to the fee. In case of split fee.
     * @return $this
     */
    public function setId($id)
    {
        $this->id = $id;

        return $this;
    }

    /**
     * @internal
     * Sets url
     * @param string $url This URL fetches the details of fee as a payment resource. In case of split fee.
     * @return $this
     */
    public function setUrl($url)
    {
        $this->url = $url;

        return $this;
    }


    private $fee_type;

    public function getFeeType()
    {
        return $this->fee_type;
    }
    

    private $fee_amount;
  
    public function getFeeAmount()
    {
        return $this->fee_amount;
    }

    private $id;
  
    public function getId()
    {
        return $this->id;
    }

    private $url;
  
    public function getUrl()
    {
        return $this->url;
    }

    
     /**
     * Fee constructor.
     * @param string $fee_amount 
     */
    public function __construct($fee_amount = null)
    {
        $this->fee_amount = $fee_amount;
    }
       
    
    
    
    
	/**
     * Specify data which should be serialized to JSON
     * @link http://php.net/manual/en/jsonserializable.jsonserialize.php
     * @return mixed data which can be serialized by <b>json_encode</b>,
     * which is a value of any type other than a resource.
     * @since 5.4.0
     */
    public function jsonSerialize()
    {
        return CommonUtil::json_serialize(get_object_vars($this) );
    }
}


