<?php

/**
 * FeePayment
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 */

/**
 * 
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 
 */


/**
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Wrappers;

use \Orbipay\PaymentsApi\Client\ObjectSerializer;
use \Orbipay\PaymentsApi\Client\MultiMap;
use \Orbipay\PaymentsApi\Client\CommonUtil;
use Orbipay\PaymentsApi\Client\OrbipayApiException;
use lf4php\LoggerFactory;


/**
 * FeePayment Class Doc Comment
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 */
class FeePayment  extends Base 
{

	const DISCRIMINATOR = null;
    
        /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'id' => 'string', 
        'url' => 'string', 
        'fee' => '\Orbipay\PaymentsApi\Client\Wrappers\Fee', 
        'status' => 'string', 
        'payment_method' => 'string', 
        'confirmation_number' => 'string', 
        'custom_fields' => 'map[string,string]', 
        'currency_code3d' => 'string', 
        'amount' => 'string', 
        'card_cvv_number' => 'string', 
        'payment_date' => 'string', 
        'payment_schedule_type' => 'string', 
        'payment_request_date' => 'string', 
        'payment_amount_type' => 'string', 
        'payment_reference' => 'string', 
        'expected_payment_settlement_date' => 'string', 
        'payment_entry_date' => 'string', 
        'payment_return_date' => 'string', 
        'return_code' => 'string', 
        'comments' => 'string', 
        'deleted' => 'string', 
        'customer' => '\Orbipay\PaymentsApi\Client\Wrappers\Customer', 
        'funding_account' => '\Orbipay\PaymentsApi\Client\Wrappers\FundingAccount', 
        'customer_account' => '\Orbipay\PaymentsApi\Client\Wrappers\CustomerAccount', 
        'payment_network_response' => '\Orbipay\PaymentsApi\Client\Wrappers\PaymentNetworkResponse', 
        'audit_info' => '\Orbipay\PaymentsApi\Client\Wrappers\AuditInfo', 
        'id_fee' => 'string', 
        'id_customer' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'id' => null,
        'url' => null,
        'fee' => null,
        'status' => null,
        'payment_method' => null,
        'confirmation_number' => null,
        'custom_fields' => null,
        'currency_code3d' => null,
        'amount' => null,
        'card_cvv_number' => null,
        'payment_date' => null,
        'payment_schedule_type' => null,
        'payment_request_date' => null,
        'payment_amount_type' => null,
        'payment_reference' => null,
        'expected_payment_settlement_date' => null,
        'payment_entry_date' => null,
        'payment_return_date' => null,
        'return_code' => null,
        'comments' => null,
        'deleted' => null,
        'customer' => null,
        'funding_account' => null,
        'customer_account' => null,
        'payment_network_response' => null,
        'audit_info' => null,
        'id_fee' => null,
        'id_customer' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'url' => 'url',
        'fee' => 'fee',
        'status' => 'status',
        'payment_method' => 'payment_method',
        'confirmation_number' => 'confirmation_number',
        'custom_fields' => 'custom_fields',
        'currency_code3d' => 'currency_code3d',
        'amount' => 'amount',
        'card_cvv_number' => 'card_cvv_number',
        'payment_date' => 'payment_date',
        'payment_schedule_type' => 'payment_schedule_type',
        'payment_request_date' => 'payment_request_date',
        'payment_amount_type' => 'payment_amount_type',
        'payment_reference' => 'payment_reference',
        'expected_payment_settlement_date' => 'expected_payment_settlement_date',
        'payment_entry_date' => 'payment_entry_date',
        'payment_return_date' => 'payment_return_date',
        'return_code' => 'return_code',
        'comments' => 'comments',
        'deleted' => 'deleted',
        'customer' => 'customer',
        'funding_account' => 'funding_account',
        'customer_account' => 'customer_account',
        'payment_network_response' => 'payment_network_response',
        'audit_info' => 'audit_info',
        'id_fee' => 'ID_FEE',
        'id_customer' => 'ID_CUSTOMER'
    ];
    
     /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'url' => 'setUrl',
        'fee' => 'setFee',
        'status' => 'setStatus',
        'payment_method' => 'setPaymentMethod',
        'confirmation_number' => 'setConfirmationNumber',
        'custom_fields' => 'setCustomFields',
        'currency_code3d' => 'setCurrencyCode3d',
        'amount' => 'setAmount',
        'card_cvv_number' => 'setCardCvvNumber',
        'payment_date' => 'setPaymentDate',
        'payment_schedule_type' => 'setPaymentScheduleType',
        'payment_request_date' => 'setPaymentRequestDate',
        'payment_amount_type' => 'setPaymentAmountType',
        'payment_reference' => 'setPaymentReference',
        'expected_payment_settlement_date' => 'setExpectedPaymentSettlementDate',
        'payment_entry_date' => 'setPaymentEntryDate',
        'payment_return_date' => 'setPaymentReturnDate',
        'return_code' => 'setReturnCode',
        'comments' => 'setComments',
        'deleted' => 'setDeleted',
        'customer' => 'setCustomer',
        'funding_account' => 'setFundingAccount',
        'customer_account' => 'setCustomerAccount',
        'payment_network_response' => 'setPaymentNetworkResponse',
        'audit_info' => 'setAuditInfo',
        'id_fee' => 'setIdFee',
        'id_customer' => 'setIdCustomer'
    ];
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'url' => 'getUrl',
        'fee' => 'getFee',
        'status' => 'getStatus',
        'payment_method' => 'getPaymentMethod',
        'confirmation_number' => 'getConfirmationNumber',
        'custom_fields' => 'getCustomFields',
        'currency_code3d' => 'getCurrencyCode3d',
        'amount' => 'getAmount',
        'card_cvv_number' => 'getCardCvvNumber',
        'payment_date' => 'getPaymentDate',
        'payment_schedule_type' => 'getPaymentScheduleType',
        'payment_request_date' => 'getPaymentRequestDate',
        'payment_amount_type' => 'getPaymentAmountType',
        'payment_reference' => 'getPaymentReference',
        'expected_payment_settlement_date' => 'getExpectedPaymentSettlementDate',
        'payment_entry_date' => 'getPaymentEntryDate',
        'payment_return_date' => 'getPaymentReturnDate',
        'return_code' => 'getReturnCode',
        'comments' => 'getComments',
        'deleted' => 'getDeleted',
        'customer' => 'getCustomer',
        'funding_account' => 'getFundingAccount',
        'customer_account' => 'getCustomerAccount',
        'payment_network_response' => 'getPaymentNetworkResponse',
        'audit_info' => 'getAuditInfo',
        'id_fee' => 'getIdFee',
        'id_customer' => 'getIdCustomer'
    ];
    
      /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }
    

    /**
     * @internal
     * Sets id
     * @param string $id The unique identifier assigned by Orbipay to the payment.
     * @return $this
     */
    public function setId($id)
    {
        $this->id = $id;

        return $this;
    }

    /**
     * @internal
     * Sets url
     * @param string $url This URL fetches the details of payment.
     * @return $this
     */
    public function setUrl($url)
    {
        $this->url = $url;

        return $this;
    }

    /**
     * @internal
     * Sets fee
     * @param \Orbipay\PaymentsApi\Client\Wrappers\Fee $fee fee
     * @return $this
     */
    public function setFee($fee)
    {
        $this->fee = $fee;

        return $this;
    }

    /**
     * @internal
     * Sets status
     * @param string $status The status of the payment.
     * @return $this
     */
    public function setStatus($status)
    {
        $this->status = $status;

        return $this;
    }

    /**
     * @internal
     * Sets payment_method
     * @param string $payment_method The fulfillment method for the payment.
     * @return $this
     */
    public function setPaymentMethod($payment_method)
    {
        $this->payment_method = $payment_method;

        return $this;
    }

    /**
     * @internal
     * Sets confirmation_number
     * @param string $confirmation_number The confirmation number or reference provided to the customer for the payment.
     * @return $this
     */
    public function setConfirmationNumber($confirmation_number)
    {
        $this->confirmation_number = $confirmation_number;

        return $this;
    }

    /**
     * @internal
     * Sets custom_fields
     * @param map[string,string] $custom_fields The additional information or meta-information that Orbipay can accept, maintain and transmit back to the client. The custom fields need to be configured with Orbipay before they can be accepted. Orbipay would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields. Only the custom fields enabled for the client, in Orbipay, would be accepted in the requests.
     * @return $this
     */
    public function setCustomFields($custom_fields)
    {
        $this->custom_fields = $custom_fields;

        return $this;
    }

    /**
     * @internal
     * Sets currency_code3d
     * @param string $currency_code3d The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by Orbipay. This defaults to USD.
     * @return $this
     */
    public function setCurrencyCode3d($currency_code3d)
    {
        $this->currency_code3d = $currency_code3d;

        return $this;
    }

    /**
     * @internal
     * Sets amount
     * @param string $amount The amount being paid. In case the payment_amount_type is 'discounted_amount', 'penalty_amount' or 'other', the amount needs to be specified. In other cases, this is derived from the payment_amount_type.
     * @return $this
     */
    public function setAmount($amount)
    {
        $this->amount = $amount;

        return $this;
    }

    /**
     * @internal
     * Sets card_cvv_number
     * @param string $card_cvv_number This is never returned by Orbipay. This needs to be passed to Orbipay when making or editing a payment with a card funding account.
     * @return $this
     */
    public function setCardCvvNumber($card_cvv_number)
    {
        $this->card_cvv_number = $card_cvv_number;

        return $this;
    }

    /**
     * @internal
     * Sets payment_date
     * @param string $payment_date The date on which the payment is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     * @return $this
     */
    public function setPaymentDate($payment_date)
    {
        $this->payment_date = $payment_date;

        return $this;
    }

    /**
     * @internal
     * Sets payment_schedule_type
     * @param string $payment_schedule_type The schedule type for the payment. This defaults to one_time_payment.
     * @return $this
     */
    public function setPaymentScheduleType($payment_schedule_type)
    {
        $this->payment_schedule_type = $payment_schedule_type;

        return $this;
    }

    /**
     * @internal
     * Sets payment_request_date
     * @param string $payment_request_date The date on which the biller wants the payment to be settled. It must be in ISO8601 full-date format, namely, YYYY-MM-DD. This is applicable only if the client has opted for it.
     * @return $this
     */
    public function setPaymentRequestDate($payment_request_date)
    {
        $this->payment_request_date = $payment_request_date;

        return $this;
    }

    /**
     * @internal
     * Sets payment_amount_type
     * @param string $payment_amount_type The type of amount, as per the bill/statement, that is being paid. The payment amount is derived from the amount type selected for the payment. This defaults to other.
     * @return $this
     */
    public function setPaymentAmountType($payment_amount_type)
    {
        $this->payment_amount_type = $payment_amount_type;

        return $this;
    }

    /**
     * @internal
     * Sets payment_reference
     * @param string $payment_reference The unique identifier in the client system for the payment.
     * @return $this
     */
    public function setPaymentReference($payment_reference)
    {
        $this->payment_reference = $payment_reference;

        return $this;
    }

    /**
     * @internal
     * Sets expected_payment_settlement_date
     * @param string $expected_payment_settlement_date The date on which the payment is expected to be settled with the biller. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     * @return $this
     */
    public function setExpectedPaymentSettlementDate($expected_payment_settlement_date)
    {
        $this->expected_payment_settlement_date = $expected_payment_settlement_date;

        return $this;
    }

    /**
     * @internal
     * Sets payment_entry_date
     * @param string $payment_entry_date The date on which the payment is captured in Orbipay. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     * @return $this
     */
    public function setPaymentEntryDate($payment_entry_date)
    {
        $this->payment_entry_date = $payment_entry_date;

        return $this;
    }

    /**
     * @internal
     * Sets payment_return_date
     * @param string $payment_return_date The date on which the ACH returns is received by Orbipay.
     * @return $this
     */
    public function setPaymentReturnDate($payment_return_date)
    {
        $this->payment_return_date = $payment_return_date;

        return $this;
    }

    /**
     * @internal
     * Sets return_code
     * @param string $return_code The ACH return code or the chargeback code received from Visa/Mastercard, in the event of returned payments.
     * @return $this
     */
    public function setReturnCode($return_code)
    {
        $this->return_code = $return_code;

        return $this;
    }

    /**
     * @internal
     * Sets comments
     * @param string $comments Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (Orbipay) is not responsible for the security of any sensitive information that may be passed as part of the memo.
     * @return $this
     */
    public function setComments($comments)
    {
        $this->comments = $comments;

        return $this;
    }

    /**
     * @internal
     * Sets deleted
     * @param string $deleted The status of payment which says whether the payment is deleted or not
     * @return $this
     */
    public function setDeleted($deleted)
    {
        $this->deleted = $deleted;

        return $this;
    }

    /**
     * @internal
     * Sets customer
     * @param \Orbipay\PaymentsApi\Client\Wrappers\Customer $customer customer
     * @return $this
     */
    public function setCustomer($customer)
    {
        $this->customer = $customer;

        return $this;
    }

    /**
     * @internal
     * Sets funding_account
     * @param \Orbipay\PaymentsApi\Client\Wrappers\FundingAccount $funding_account funding_account
     * @return $this
     */
    public function setFundingAccount($funding_account)
    {
        $this->funding_account = $funding_account;

        return $this;
    }

    /**
     * @internal
     * Sets customer_account
     * @param \Orbipay\PaymentsApi\Client\Wrappers\CustomerAccount $customer_account customer_account
     * @return $this
     */
    public function setCustomerAccount($customer_account)
    {
        $this->customer_account = $customer_account;

        return $this;
    }

    /**
     * @internal
     * Sets payment_network_response
     * @param \Orbipay\PaymentsApi\Client\Wrappers\PaymentNetworkResponse $payment_network_response payment_network_response
     * @return $this
     */
    public function setPaymentNetworkResponse($payment_network_response)
    {
        $this->payment_network_response = $payment_network_response;

        return $this;
    }

    /**
     * @internal
     * Sets audit_info
     * @param \Orbipay\PaymentsApi\Client\Wrappers\AuditInfo $audit_info audit_info
     * @return $this
     */
    public function setAuditInfo($audit_info)
    {
        $this->audit_info = $audit_info;

        return $this;
    }

    /**
     * @internal
     * Sets id_fee
     * @param string $id_fee The unique identifier assigned by OrbiPay to the FeePayment.
     * @return $this
     */
    public function setIdFee($id_fee)
    {
        $this->id_fee = $id_fee;

        return $this;
    }

    /**
     * @internal
     * Sets id_customer
     * @param string $id_customer The unique identifier assigned by OrbiPay to the customer.
     * @return $this
     */
    public function setIdCustomer($id_customer)
    {
        $this->id_customer = $id_customer;

        return $this;
    }


    private $id;
  
    public function getId()
    {
        return $this->id;
    }

    private $url;
  
    public function getUrl()
    {
        return $this->url;
    }

    private $fee;
  
    public function getFee()
    {
        return $this->fee;
    }

    private $status;

    public function getStatus()
    {
        return $this->status;
    }
    

    private $payment_method;

    public function getPaymentMethod()
    {
        return $this->payment_method;
    }
    

    private $confirmation_number;
  
    public function getConfirmationNumber()
    {
        return $this->confirmation_number;
    }

    private $custom_fields;
  
    public function getCustomFields()
    {
        return $this->custom_fields;
    }

    private $currency_code3d;
  
    public function getCurrencyCode3d()
    {
        return $this->currency_code3d;
    }

    private $amount;
  
    public function getAmount()
    {
        return $this->amount;
    }

    private $card_cvv_number;
  
    public function getCardCvvNumber()
    {
        return $this->card_cvv_number;
    }

    private $payment_date;
  
    public function getPaymentDate()
    {
        return $this->payment_date;
    }

    private $payment_schedule_type;

    public function getPaymentScheduleType()
    {
        return $this->payment_schedule_type;
    }
    

    private $payment_request_date;
  
    public function getPaymentRequestDate()
    {
        return $this->payment_request_date;
    }

    private $payment_amount_type;

    public function getPaymentAmountType()
    {
        return $this->payment_amount_type;
    }
    

    private $payment_reference;
  
    public function getPaymentReference()
    {
        return $this->payment_reference;
    }

    private $expected_payment_settlement_date;
  
    public function getExpectedPaymentSettlementDate()
    {
        return $this->expected_payment_settlement_date;
    }

    private $payment_entry_date;
  
    public function getPaymentEntryDate()
    {
        return $this->payment_entry_date;
    }

    private $payment_return_date;
  
    public function getPaymentReturnDate()
    {
        return $this->payment_return_date;
    }

    private $return_code;
  
    public function getReturnCode()
    {
        return $this->return_code;
    }

    private $comments;
  
    public function getComments()
    {
        return $this->comments;
    }

    private $deleted;
  
    public function getDeleted()
    {
        return $this->deleted;
    }

    private $customer;
  
    public function getCustomer()
    {
        return $this->customer;
    }

    private $funding_account;
  
    public function getFundingAccount()
    {
        return $this->funding_account;
    }

    private $customer_account;
  
    public function getCustomerAccount()
    {
        return $this->customer_account;
    }

    private $payment_network_response;
  
    public function getPaymentNetworkResponse()
    {
        return $this->payment_network_response;
    }

    private $audit_info;
  
    public function getAuditInfo()
    {
        return $this->audit_info;
    }

    private $id_fee;
  
    public function getIdFee()
    {
        return $this->id_fee;
    }

    private $id_customer;
  
    public function getIdCustomer()
    {
        return $this->id_customer;
    }

    
     /**
     * FeePayment constructor.
     * @param string $id_fee 
     */
    public function __construct($id_fee = null)
    {
        $this->id_fee = $id_fee;
    }
       
    public function forClient($client_key = null)
    {
		parent::forClient($client_key);
        
        return $this; 
    }
    public function videChannel($channel = null)
    {
		parent::videChannel($channel);
        
        return $this; 
    }
    public function withDetails($payment_amount_type = null, $amount = null, $payment_date = null, $payment_request_date = null, $card_cvv_number = null)
    {
        			$this->payment_amount_type = $payment_amount_type;
        		
        

        			$this->amount = $amount;
        		
        

        			$this->payment_date = $payment_date;
        		
        

        			$this->payment_request_date = $payment_request_date;
        		
        

        			$this->card_cvv_number = $card_cvv_number;
        		
        

        
        return $this; 
    }
    public function fromAccount($funding_account = null)
    {
        			$this->funding_account = $funding_account;
        		
        

        
        return $this; 
    }
    public function toAccount($customer_account = null)
    {
        			$this->customer_account = $customer_account;
        		
        

        
        return $this; 
    }
    public function withReference($payment_reference = null)
    {
        			$this->payment_reference = $payment_reference;
        		
        

        
        return $this; 
    }
    public function withStatus($status = null)
    {
        			$this->status = $status;
        		
        

        
        return $this; 
    }
    public function withCustomFields($custom_fields = null)
    {
				if(isset($custom_fields)){
					if(count($custom_fields) == 0){
						$this->custom_fields = null;
					}
					else{
        				$this->custom_fields = $custom_fields;
					}
        		}else{
        			$this->custom_fields = $custom_fields;
        		}
        		
        

        
        return $this; 
    }
    public function withMemo($comments = null)
    {
        			$this->comments = $comments;
        		
        

        
        return $this; 
    }
    public function withFee($fee = null)
    {
        			$this->fee = $fee;
        		
        

        
        return $this; 
    }
    public function forCustomer($id_customer = null)
    {
        			$this->id_customer = $id_customer;
        		
        

        
        return $this; 
    }
    
    public function retrievedBy($requestor = null , $requestor_type = null )
    {
       $this->requestedBy( $requestor, $requestor_type);
       return $this;
    }

    
    public function get(InvocationContext $invocationContext, $liveMode = null,  $apiEndPoint = null)
    {
     	try {
	    	$this->withContext($invocationContext, $liveMode, $apiEndPoint);
	    	$handler = new  \Orbipay\PaymentsApi\Client\Handlers\RetrieveFeePaymentHandler();
	        return $handler->process($this);
		} catch (OrbipayApiException $e) {
            throw $e;
        } catch (\Exception $e) {
             $logger = LoggerFactory::getLogger(__CLASS__);
             $logger->error($e->getMessage());
            throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
        }
    }
    
    
	/**
     * Specify data which should be serialized to JSON
     * @link http://php.net/manual/en/jsonserializable.jsonserialize.php
     * @return mixed data which can be serialized by <b>json_encode</b>,
     * which is a value of any type other than a resource.
     * @since 5.4.0
     */
    public function jsonSerialize()
    {
        return CommonUtil::json_serialize(get_object_vars($this) , parent::jsonSerialize());
    }
}


