<?php

/**
 * FundingAccount
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 */

/**
 * 
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 
 */


/**
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Wrappers;

use \Orbipay\PaymentsApi\Client\ObjectSerializer;
use \Orbipay\PaymentsApi\Client\MultiMap;
use \Orbipay\PaymentsApi\Client\CommonUtil;
use Orbipay\PaymentsApi\Client\OrbipayApiException;
use lf4php\LoggerFactory;


/**
 * FundingAccount Class Doc Comment
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 */
class FundingAccount  extends Base 
{

	const DISCRIMINATOR = null;
    
        /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'account_holder_name' => 'string', 
        'nickname' => 'string', 
        'address' => '\Orbipay\PaymentsApi\Client\Wrappers\Address', 
        'account_number' => 'string', 
        'aba_routing_number' => 'string', 
        'issuer_name' => 'string', 
        'currency_code3d' => 'string', 
        'expiry_date' => 'string', 
        'account_holder_type' => 'string', 
        'custom_fields' => 'map[string,string]', 
        'account_subtype' => 'string', 
        'id' => 'string', 
        'url' => 'string', 
        'ach_eligible_flag' => 'string', 
        'atm_eligible_flag' => 'string', 
        'card_cvv_number' => 'string', 
        'account_type' => 'string', 
        'status' => 'string', 
        'comments' => 'string', 
        'deleted' => 'string', 
        'audit_info' => '\Orbipay\PaymentsApi\Client\Wrappers\AuditInfo', 
        'id_customer' => 'string', 
        'id_funding_account' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'account_holder_name' => null,
        'nickname' => null,
        'address' => null,
        'account_number' => null,
        'aba_routing_number' => null,
        'issuer_name' => null,
        'currency_code3d' => null,
        'expiry_date' => null,
        'account_holder_type' => null,
        'custom_fields' => null,
        'account_subtype' => null,
        'id' => null,
        'url' => null,
        'ach_eligible_flag' => null,
        'atm_eligible_flag' => null,
        'card_cvv_number' => null,
        'account_type' => null,
        'status' => null,
        'comments' => null,
        'deleted' => null,
        'audit_info' => null,
        'id_customer' => null,
        'id_funding_account' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'account_holder_name' => 'account_holder_name',
        'nickname' => 'nickname',
        'address' => 'address',
        'account_number' => 'account_number',
        'aba_routing_number' => 'aba_routing_number',
        'issuer_name' => 'issuer_name',
        'currency_code3d' => 'currency_code3d',
        'expiry_date' => 'expiry_date',
        'account_holder_type' => 'account_holder_type',
        'custom_fields' => 'custom_fields',
        'account_subtype' => 'account_subtype',
        'id' => 'id',
        'url' => 'url',
        'ach_eligible_flag' => 'ach_eligible_flag',
        'atm_eligible_flag' => 'atm_eligible_flag',
        'card_cvv_number' => 'card_cvv_number',
        'account_type' => 'account_type',
        'status' => 'status',
        'comments' => 'comments',
        'deleted' => 'deleted',
        'audit_info' => 'audit_info',
        'id_customer' => 'ID_CUSTOMER',
        'id_funding_account' => 'ID_FUNDING_ACCOUNT'
    ];
    
     /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'account_holder_name' => 'setAccountHolderName',
        'nickname' => 'setNickname',
        'address' => 'setAddress',
        'account_number' => 'setAccountNumber',
        'aba_routing_number' => 'setAbaRoutingNumber',
        'issuer_name' => 'setIssuerName',
        'currency_code3d' => 'setCurrencyCode3d',
        'expiry_date' => 'setExpiryDate',
        'account_holder_type' => 'setAccountHolderType',
        'custom_fields' => 'setCustomFields',
        'account_subtype' => 'setAccountSubtype',
        'id' => 'setId',
        'url' => 'setUrl',
        'ach_eligible_flag' => 'setAchEligibleFlag',
        'atm_eligible_flag' => 'setAtmEligibleFlag',
        'card_cvv_number' => 'setCardCvvNumber',
        'account_type' => 'setAccountType',
        'status' => 'setStatus',
        'comments' => 'setComments',
        'deleted' => 'setDeleted',
        'audit_info' => 'setAuditInfo',
        'id_customer' => 'setIdCustomer',
        'id_funding_account' => 'setIdFundingAccount'
    ];
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'account_holder_name' => 'getAccountHolderName',
        'nickname' => 'getNickname',
        'address' => 'getAddress',
        'account_number' => 'getAccountNumber',
        'aba_routing_number' => 'getAbaRoutingNumber',
        'issuer_name' => 'getIssuerName',
        'currency_code3d' => 'getCurrencyCode3d',
        'expiry_date' => 'getExpiryDate',
        'account_holder_type' => 'getAccountHolderType',
        'custom_fields' => 'getCustomFields',
        'account_subtype' => 'getAccountSubtype',
        'id' => 'getId',
        'url' => 'getUrl',
        'ach_eligible_flag' => 'getAchEligibleFlag',
        'atm_eligible_flag' => 'getAtmEligibleFlag',
        'card_cvv_number' => 'getCardCvvNumber',
        'account_type' => 'getAccountType',
        'status' => 'getStatus',
        'comments' => 'getComments',
        'deleted' => 'getDeleted',
        'audit_info' => 'getAuditInfo',
        'id_customer' => 'getIdCustomer',
        'id_funding_account' => 'getIdFundingAccount'
    ];
    
      /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }
    

    /**
     * @internal
     * Sets account_holder_name
     * @param string $account_holder_name The name as specified on the account.
     * @return $this
     */
    public function setAccountHolderName($account_holder_name)
    {
        $this->account_holder_name = $account_holder_name;

        return $this;
    }

    /**
     * @internal
     * Sets nickname
     * @param string $nickname The nickname by which a customer might want to identify the account.
     * @return $this
     */
    public function setNickname($nickname)
    {
        $this->nickname = $nickname;

        return $this;
    }

    /**
     * @internal
     * Sets address
     * @param \Orbipay\PaymentsApi\Client\Wrappers\Address $address address
     * @return $this
     */
    public function setAddress($address)
    {
        $this->address = $address;

        return $this;
    }

    /**
     * @internal
     * Sets account_number
     * @param string $account_number The number or reference that a customer uses to identify the funding account.
     * @return $this
     */
    public function setAccountNumber($account_number)
    {
        $this->account_number = $account_number;

        return $this;
    }

    /**
     * @internal
     * Sets aba_routing_number
     * @param string $aba_routing_number The ABA/Routing number for the bank account.
     * @return $this
     */
    public function setAbaRoutingNumber($aba_routing_number)
    {
        $this->aba_routing_number = $aba_routing_number;

        return $this;
    }

    /**
     * @internal
     * Sets issuer_name
     * @param string $issuer_name The name of the authority that has issued the account. This is relevant only in the case of bank accounts.
     * @return $this
     */
    public function setIssuerName($issuer_name)
    {
        $this->issuer_name = $issuer_name;

        return $this;
    }

    /**
     * @internal
     * Sets currency_code3d
     * @param string $currency_code3d The three-letter currency code in the ISO4217 format, in uppercase, for the card account. It must be a currency supported by Orbipay. This defaults to USD.
     * @return $this
     */
    public function setCurrencyCode3d($currency_code3d)
    {
        $this->currency_code3d = $currency_code3d;

        return $this;
    }

    /**
     * @internal
     * Sets expiry_date
     * @param string $expiry_date The expiry date for the card. This is to be in the format MM/yy. Only applicable for cards accounts.
     * @return $this
     */
    public function setExpiryDate($expiry_date)
    {
        $this->expiry_date = $expiry_date;

        return $this;
    }

    /**
     * @internal
     * Sets account_holder_type
     * @param string $account_holder_type The type of ownership for the funding account. This is applicable only in the case of bank accounts and it is defaults to personal.
     * @return $this
     */
    public function setAccountHolderType($account_holder_type)
    {
        $this->account_holder_type = $account_holder_type;

        return $this;
    }

    /**
     * @internal
     * Sets custom_fields
     * @param map[string,string] $custom_fields The additional information or meta-information that Orbipay can accept, maintain and transmit back to the client. The custom fields need to be configured with Orbipay before they can be accepted. Orbipay would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields. Only the custom fields enabled for the client, in Orbipay, would be accepted in the requests.
     * @return $this
     */
    public function setCustomFields($custom_fields)
    {
        $this->custom_fields = $custom_fields;

        return $this;
    }

    /**
     * @internal
     * Sets account_subtype
     * @param string $account_subtype The sub type of the funding account. This is derived by Orbipay in the case of card funding accounts. It needs to be passed when adding or editing a DDA/bank account. For e.g., a savings account, a checking account.
     * @return $this
     */
    public function setAccountSubtype($account_subtype)
    {
        $this->account_subtype = $account_subtype;

        return $this;
    }

    /**
     * @internal
     * Sets id
     * @param string $id Id is a unique identifier assigned to the funding account in Orbipay. A new Id is generated for the funding account when the account number is updated.
     * @return $this
     */
    public function setId($id)
    {
        $this->id = $id;

        return $this;
    }

    /**
     * @internal
     * Sets url
     * @param string $url This URL fetches the funding account details.
     * @return $this
     */
    public function setUrl($url)
    {
        $this->url = $url;

        return $this;
    }

    /**
     * @internal
     * Sets ach_eligible_flag
     * @param string $ach_eligible_flag Indicates if the funding account can be debited vide ACH, in case the funding account is a Demand Deposit Account (DDA).
     * @return $this
     */
    public function setAchEligibleFlag($ach_eligible_flag)
    {
        $this->ach_eligible_flag = $ach_eligible_flag;

        return $this;
    }

    /**
     * @internal
     * Sets atm_eligible_flag
     * @param string $atm_eligible_flag Indicates if the funding account can be debited vide the ATM Rail network, in case the funding account is a Debit Card.
     * @return $this
     */
    public function setAtmEligibleFlag($atm_eligible_flag)
    {
        $this->atm_eligible_flag = $atm_eligible_flag;

        return $this;
    }

    /**
     * @internal
     * Sets card_cvv_number
     * @param string $card_cvv_number This is never returned by Orbipay. This needs to be passed to Orbipay when adding or editing a card funding account.
     * @return $this
     */
    public function setCardCvvNumber($card_cvv_number)
    {
        $this->card_cvv_number = $card_cvv_number;

        return $this;
    }

    /**
     * @internal
     * Sets account_type
     * @param string $account_type The type of the funding account.
     * @return $this
     */
    public function setAccountType($account_type)
    {
        $this->account_type = $account_type;

        return $this;
    }

    /**
     * @internal
     * Sets status
     * @param string $status The status of the funding account in Orbipay.
     * @return $this
     */
    public function setStatus($status)
    {
        $this->status = $status;

        return $this;
    }

    /**
     * @internal
     * Sets comments
     * @param string $comments Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (Orbipay) is not responsible for the security of any sensitive information that may be passed as part of the memo.
     * @return $this
     */
    public function setComments($comments)
    {
        $this->comments = $comments;

        return $this;
    }

    /**
     * @internal
     * Sets deleted
     * @param string $deleted The status of funding account which says whether the funding account is deleted or not
     * @return $this
     */
    public function setDeleted($deleted)
    {
        $this->deleted = $deleted;

        return $this;
    }

    /**
     * @internal
     * Sets audit_info
     * @param \Orbipay\PaymentsApi\Client\Wrappers\AuditInfo $audit_info audit_info
     * @return $this
     */
    public function setAuditInfo($audit_info)
    {
        $this->audit_info = $audit_info;

        return $this;
    }

    /**
     * @internal
     * Sets id_customer
     * @param string $id_customer The unique identifier assigned by Orbipay to the customer.
     * @return $this
     */
    public function setIdCustomer($id_customer)
    {
        $this->id_customer = $id_customer;

        return $this;
    }

    /**
     * @internal
     * Sets id_funding_account
     * @param string $id_funding_account The unique identifier assigned by Orbipay to the Funding Account.
     * @return $this
     */
    public function setIdFundingAccount($id_funding_account)
    {
        $this->id_funding_account = $id_funding_account;

        return $this;
    }


    private $account_holder_name;
  
    public function getAccountHolderName()
    {
        return $this->account_holder_name;
    }

    private $nickname;
  
    public function getNickname()
    {
        return $this->nickname;
    }

    private $address;
  
    public function getAddress()
    {
        return $this->address;
    }

    private $account_number;
  
    public function getAccountNumber()
    {
        return $this->account_number;
    }

    private $aba_routing_number;
  
    public function getAbaRoutingNumber()
    {
        return $this->aba_routing_number;
    }

    private $issuer_name;
  
    public function getIssuerName()
    {
        return $this->issuer_name;
    }

    private $currency_code3d;
  
    public function getCurrencyCode3d()
    {
        return $this->currency_code3d;
    }

    private $expiry_date;
  
    public function getExpiryDate()
    {
        return $this->expiry_date;
    }

    private $account_holder_type;

    public function getAccountHolderType()
    {
        return $this->account_holder_type;
    }
    

    private $custom_fields;
  
    public function getCustomFields()
    {
        return $this->custom_fields;
    }

    private $account_subtype;

    public function getAccountSubtype()
    {
        return $this->account_subtype;
    }
    

    private $id;
  
    public function getId()
    {
        return $this->id;
    }

    private $url;
  
    public function getUrl()
    {
        return $this->url;
    }

    private $ach_eligible_flag;

    public function getAchEligibleFlag()
    {
        return $this->ach_eligible_flag;
    }
    

    private $atm_eligible_flag;

    public function getAtmEligibleFlag()
    {
        return $this->atm_eligible_flag;
    }
    

    private $card_cvv_number;
  
    public function getCardCvvNumber()
    {
        return $this->card_cvv_number;
    }

    private $account_type;

    public function getAccountType()
    {
        return $this->account_type;
    }
    

    private $status;

    public function getStatus()
    {
        return $this->status;
    }
    

    private $comments;
  
    public function getComments()
    {
        return $this->comments;
    }

    private $deleted;
  
    public function getDeleted()
    {
        return $this->deleted;
    }

    private $audit_info;
  
    public function getAuditInfo()
    {
        return $this->audit_info;
    }

    private $id_customer;
  
    public function getIdCustomer()
    {
        return $this->id_customer;
    }

    private $id_funding_account;
  
    public function getIdFundingAccount()
    {
        return $this->id_funding_account;
    }

    
     /**
     * FundingAccount constructor.
     * @param string $id_funding_account 
     */
    public function __construct($id_funding_account = null)
    {
        $this->id_funding_account = $id_funding_account;
		$this->id = $id_funding_account;
    }
       
    public function forClient($client_key = null)
    {
		parent::forClient($client_key);
        
        return $this; 
    }
    public function videChannel($channel = null)
    {
		parent::videChannel($channel);
        
        return $this; 
    }
    public function withDetails($account_holder_name = null, $nickname = null, $account_number = null, $account_subtype = null, $aba_routing_number = null, $card_cvv_number = null, $expiry_date = null, $account_holder_type = null)
    {
        			$this->account_holder_name = $account_holder_name;
        		
        

        			$this->nickname = $nickname;
        		
        

        			$this->account_number = $account_number;
        		
        

        			$this->account_subtype = $account_subtype;
        		
        

        			$this->aba_routing_number = $aba_routing_number;
        		
        

        			$this->card_cvv_number = $card_cvv_number;
        		
        

        			$this->expiry_date = $expiry_date;
        		
        

        			$this->account_holder_type = $account_holder_type;
        		
        

        
        return $this; 
    }
    public function withStatus($status = null)
    {
        			$this->status = $status;
        		
        

        
        return $this; 
    }
    public function withAddress($address = null)
    {
        			$this->address = $address;
        		
        

        
        return $this; 
    }
    public function withCustomFields($custom_fields = null)
    {
				if(isset($custom_fields)){
					if(count($custom_fields) == 0){
						$this->custom_fields = null;
					}
					else{
        				$this->custom_fields = $custom_fields;
					}
        		}else{
        			$this->custom_fields = $custom_fields;
        		}
        		
        

        
        return $this; 
    }
    public function withMemo($comments = null)
    {
        			$this->comments = $comments;
        		
        

        
        return $this; 
    }
    public function forCustomer($id_customer = null)
    {
        			$this->id_customer = $id_customer;
        		
        

        
        return $this; 
    }
    
    public function createdBy($requestor = null , $requestor_type = null )
    {
       $this->requestedBy( $requestor, $requestor_type);
       return $this;
    }

    public function deletedBy($requestor = null , $requestor_type = null )
    {
       $this->requestedBy( $requestor, $requestor_type);
       return $this;
    }

    public function replacedBy($requestor = null , $requestor_type = null )
    {
       $this->requestedBy( $requestor, $requestor_type);
       return $this;
    }

    public function retrievedBy($requestor = null , $requestor_type = null )
    {
       $this->requestedBy( $requestor, $requestor_type);
       return $this;
    }

    public function updatedBy($requestor = null , $requestor_type = null )
    {
       $this->requestedBy( $requestor, $requestor_type);
       return $this;
    }

    
    public function create(InvocationContext $invocationContext, $liveMode = null,  $apiEndPoint = null)
    {
     	try {
	    	$this->withContext($invocationContext, $liveMode, $apiEndPoint);
	    	$handler = new  \Orbipay\PaymentsApi\Client\Handlers\CreateFundingAccountHandler();
	        return $handler->process($this);
		} catch (OrbipayApiException $e) {
            throw $e;
        } catch (\Exception $e) {
             $logger = LoggerFactory::getLogger(__CLASS__);
             $logger->error($e->getMessage());
            throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
        }
    }
    public function delete(InvocationContext $invocationContext, $liveMode = null,  $apiEndPoint = null)
    {
     	try {
	    	$this->withContext($invocationContext, $liveMode, $apiEndPoint);
	    	$handler = new  \Orbipay\PaymentsApi\Client\Handlers\DeleteFundingAccountHandler();
	        return $handler->process($this);
		} catch (OrbipayApiException $e) {
            throw $e;
        } catch (\Exception $e) {
             $logger = LoggerFactory::getLogger(__CLASS__);
             $logger->error($e->getMessage());
            throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
        }
    }
    public function replace(InvocationContext $invocationContext, $liveMode = null,  $apiEndPoint = null)
    {
     	try {
	    	$this->withContext($invocationContext, $liveMode, $apiEndPoint);
	    	$handler = new  \Orbipay\PaymentsApi\Client\Handlers\ReplaceFundingAccountHandler();
	        return $handler->process($this);
		} catch (OrbipayApiException $e) {
            throw $e;
        } catch (\Exception $e) {
             $logger = LoggerFactory::getLogger(__CLASS__);
             $logger->error($e->getMessage());
            throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
        }
    }
    public function get(InvocationContext $invocationContext, $liveMode = null,  $apiEndPoint = null)
    {
     	try {
	    	$this->withContext($invocationContext, $liveMode, $apiEndPoint);
	    	$handler = new  \Orbipay\PaymentsApi\Client\Handlers\RetrieveFundingAccountHandler();
	        return $handler->process($this);
		} catch (OrbipayApiException $e) {
            throw $e;
        } catch (\Exception $e) {
             $logger = LoggerFactory::getLogger(__CLASS__);
             $logger->error($e->getMessage());
            throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
        }
    }
    public function update(InvocationContext $invocationContext, $liveMode = null,  $apiEndPoint = null)
    {
     	try {
	    	$this->withContext($invocationContext, $liveMode, $apiEndPoint);
	    	$handler = new  \Orbipay\PaymentsApi\Client\Handlers\UpdateFundingAccountHandler();
	        return $handler->process($this);
		} catch (OrbipayApiException $e) {
            throw $e;
        } catch (\Exception $e) {
             $logger = LoggerFactory::getLogger(__CLASS__);
             $logger->error($e->getMessage());
            throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
        }
    }
    
    
	/**
     * Specify data which should be serialized to JSON
     * @link http://php.net/manual/en/jsonserializable.jsonserialize.php
     * @return mixed data which can be serialized by <b>json_encode</b>,
     * which is a value of any type other than a resource.
     * @since 5.4.0
     */
    public function jsonSerialize()
    {
        return CommonUtil::json_serialize(get_object_vars($this) , parent::jsonSerialize());
    }
}


