<?php

/**
 * InvocationContext
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 * @author   Swagger Codegen team
 * @link     https://github.com/swagger-api/swagger-codegen
 */

namespace Orbipay\PaymentsApi\Client\Wrappers;


use \ArrayAccess;
use \Orbipay\PaymentsApi\Client\ObjectSerializer;
use \Orbipay\PaymentsApi\Client\CommonUtil;

class InvocationContext 
{
	
	const DISCRIMINATOR = null;

	/**
      * The original name of the model.
      *
      * @var string
      */
    protected static $swaggerModelName = 'InvocationContext';
    
        /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'client_key' => 'string', 
        'product' => 'string', 
        'x_opay_headers' => 'string', 
        'requestor_type' => 'string', 
        'idempotent_request_key' => 'string', 
        'request_uuid' => 'string', 
        'channel' => 'string', 
        'response_codes' => 'string', 
        'response_text' => 'string', 
        'requestor' => 'string', 
        'timestamp' => 'string', 
        'secret' => 'String'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'client_key' => null,
        'product' => null,
        'x_opay_headers' => null,
        'requestor_type' => null,
        'idempotent_request_key' => null,
        'request_uuid' => null,
        'channel' => null,
        'response_codes' => null,
        'response_text' => null,
        'requestor' => null,
        'timestamp' => null,
        'secret' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'client_key' => 'client_key',
        'product' => 'product',
        'x_opay_headers' => 'X-OPAY-Headers',
        'requestor_type' => 'requestor_type',
        'idempotent_request_key' => 'idempotent_request_key',
        'request_uuid' => 'request_uuid',
        'channel' => 'channel',
        'response_codes' => 'response_codes',
        'response_text' => 'response_text',
        'requestor' => 'requestor',
        'timestamp' => 'timestamp',
        'secret' => 'secret'
    ];
    
     /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'client_key' => 'setClientKey',
        'product' => 'setProduct',
        'x_opay_headers' => 'setXOpayHeaders',
        'requestor_type' => 'setRequestorType',
        'idempotent_request_key' => 'setIdempotentRequestKey',
        'request_uuid' => 'setRequestUuid',
        'channel' => 'setChannel',
        'response_codes' => 'setResponseCodes',
        'response_text' => 'setResponseText',
        'requestor' => 'setRequestor',
        'timestamp' => 'setTimestamp',
        'secret' => 'setSecret'
    ];
    
      /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }
    
    

    /**
     * @internal
     * Sets client_key
     * @param string $client_key The unique identifier assigned by Orbipay to the client.
     * @return $this
     */
    public function setClientKey($client_key)
    {
        $this->client_key = $client_key;

        return $this;
    }

    /**
     * @internal
     * Sets product
     * @param string $product The product identifier corresponding to the API.
     * @return $this
     */
    public function setProduct($product)
    {
        $this->product = $product;

        return $this;
    }

    /**
     * @internal
     * Sets x_opay_headers
     * @param string $x_opay_headers Intended for the future use.
     * @return $this
     */
    public function setXOpayHeaders($x_opay_headers)
    {
        $this->x_opay_headers = $x_opay_headers;

        return $this;
    }

    /**
     * @internal
     * Sets requestor_type
     * @param string $requestor_type If an API is being requested from an application that is being used directly by a customer, like the customer portal and IVR, the requestor_type should be set to \"customer\".</br> If an API is being requested from an application that is being used by third party agents/brokers servicing a customer on behalf of a biller/client, then the requestor_type should be set to \"external_user\". It should be noted that these users would not have logins for the Orbipay EBPP Portal or Payment Center.
     * @return $this
     */
    public function setRequestorType($requestor_type)
    {
        $this->requestor_type = $requestor_type;

        return $this;
    }

    /**
     * @internal
     * Sets idempotent_request_key
     * @param string $idempotent_request_key The unique token that clients can generate and maintain in order to identify an API request. This is used by Orbipay to identify duplicate requests and retrials. Please refer to the \"<a href=\"#duplicate-requests-&-retrials\">Duplicate Requests & Retrials</a>\" section for more details.
     * @return $this
     */
    public function setIdempotentRequestKey($idempotent_request_key)
    {
        $this->idempotent_request_key = $idempotent_request_key;

        return $this;
    }

    /**
     * @internal
     * Sets request_uuid
     * @param string $request_uuid The unique ID for the request, generated by Orbipay, that can be used for tracing and audit trail.
     * @return $this
     */
    public function setRequestUuid($request_uuid)
    {
        $this->request_uuid = $request_uuid;

        return $this;
    }

    /**
     * @internal
     * Sets channel
     * @param string $channel The channel through which the API is invoked. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> to configure channels.
     * @return $this
     */
    public function setChannel($channel)
    {
        $this->channel = $channel;

        return $this;
    }

    /**
     * @internal
     * Sets response_codes
     * @param string $response_codes Codes corresponding to any additional information or warning, pertaining to the API call, in a comma separated format, that are returned in the response.
     * @return $this
     */
    public function setResponseCodes($response_codes)
    {
        $this->response_codes = $response_codes;

        return $this;
    }

    /**
     * @internal
     * Sets response_text
     * @param string $response_text The text detailing any additional information or warning, pertaining to the API call, in a pipe separated format, that is returned in the response.
     * @return $this
     */
    public function setResponseText($response_text)
    {
        $this->response_text = $response_text;

        return $this;
    }

    /**
     * @internal
     * Sets requestor
     * @param string $requestor The identifier for the requestor of the API, in Orbipay. The value to be passed in the requestor field would depend on the requestor_type.</br> If the requestor_type is \"customer\", the requestor should be the Orbipay generated customer id. In the case of self registration, where there is no Orbipay generated customer id yet, the requestor should be set to 'guest'.</br> If the requestor_type is \"external_user\", the requestor can be any unique identifier that the client may have for the external agent.
     * @return $this
     */
    public function setRequestor($requestor)
    {
        $this->requestor = $requestor;

        return $this;
    }

    /**
     * @internal
     * Sets timestamp
     * @param string $timestamp The timestamp for the moment when the API call is made, in the format, <b>yyyy-MM-dd HH:mm:ss.SSSZ</b></br> For e.g., <i>2018-07-13 11:41:17.422+00:00</i>  Please ensure that consecutive spaces are not used in the timestamp.
     * @return $this
     */
    public function setTimestamp($timestamp)
    {
        $this->timestamp = $timestamp;

        return $this;
    }

    /**
     * @internal
     * Sets secret
     * @param String $secret secret
     * @return $this
     */
    public function setSecret($secret)
    {
        $this->secret = $secret;

        return $this;
    }

	
    private $client_key;
  
    public function getClientKey()
    {
        return $this->client_key;
    }
        
    private $product;

    public function getProduct()
    {
        return $this->product;
    }
    
	
    private $x_opay_headers;
  
    public function getXOpayHeaders()
    {
        return $this->x_opay_headers;
    }
        
    private $requestor_type;

    public function getRequestorType()
    {
        return $this->requestor_type;
    }
    
	
    private $idempotent_request_key;
  
    public function getIdempotentRequestKey()
    {
        return $this->idempotent_request_key;
    }
	
    private $request_uuid;
  
    public function getRequestUuid()
    {
        return $this->request_uuid;
    }
	
    private $channel;
  
    public function getChannel()
    {
        return $this->channel;
    }
	
    private $response_codes;
  
    public function getResponseCodes()
    {
        return $this->response_codes;
    }
	
    private $response_text;
  
    public function getResponseText()
    {
        return $this->response_text;
    }
	
    private $requestor;
  
    public function getRequestor()
    {
        return $this->requestor;
    }
	
    private $timestamp;
  
    public function getTimestamp()
    {
        return $this->timestamp;
    }
	
    private $secret;
  
    public function getSecret()
    {
        return $this->secret;
    }

    
     /**
     * InvocationContext constructor.
     * @param string $product 
     * @param String $secret 
     * @param string $idempotent_request_key 
     * @param string $x_opay_headers 
     */
    public function __construct($secret = null, $idempotent_request_key = null, $x_opay_headers = null)
    {
		$this->product  = "orbipay_payments";
        $this->secret = $secret;
        $this->idempotent_request_key = $idempotent_request_key;
        $this->x_opay_headers = $x_opay_headers;
    }
    
       
    
    
    
    
    
    
    
    
	/**
     * Specify data which should be serialized to JSON
     * @link http://php.net/manual/en/jsonserializable.jsonserialize.php
     * @return mixed data which can be serialized by <b>json_encode</b>,
     * which is a value of any type other than a resource.
     * @since 5.4.0
     */
    public function jsonSerialize()
    {
        return CommonUtil::json_serialize(get_object_vars($this) );
    }
}
