<?php

/**
 * PaymentSchedule
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 */

/**
 * 
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 
 */


/**
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Wrappers;

use \Orbipay\PaymentsApi\Client\ObjectSerializer;
use \Orbipay\PaymentsApi\Client\MultiMap;
use \Orbipay\PaymentsApi\Client\CommonUtil;
use Orbipay\PaymentsApi\Client\OrbipayApiException;
use lf4php\LoggerFactory;


/**
 * PaymentSchedule Class Doc Comment
 * @category Class
 * @description The schedule for the payments that are created as part of a payment setup like recurring payment or autopay.
 * @package  Orbipay\PaymentsApi\Client
 */
class PaymentSchedule  
{

	const DISCRIMINATOR = null;
    
        /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'payment_recurring_type' => 'string', 
        'payment_recurring_count' => 'string', 
        'payment_amount_type' => 'string', 
        'payment_start_date' => 'string', 
        'payment_end_date' => 'string', 
        'payment_limit_amount' => 'string', 
        'payment_plan_id' => 'string', 
        'payment_defer_days' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'payment_recurring_type' => null,
        'payment_recurring_count' => null,
        'payment_amount_type' => null,
        'payment_start_date' => null,
        'payment_end_date' => null,
        'payment_limit_amount' => null,
        'payment_plan_id' => null,
        'payment_defer_days' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'payment_recurring_type' => 'payment_recurring_type',
        'payment_recurring_count' => 'payment_recurring_count',
        'payment_amount_type' => 'payment_amount_type',
        'payment_start_date' => 'payment_start_date',
        'payment_end_date' => 'payment_end_date',
        'payment_limit_amount' => 'payment_limit_amount',
        'payment_plan_id' => 'payment_plan_id',
        'payment_defer_days' => 'payment_defer_days'
    ];
    
     /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'payment_recurring_type' => 'setPaymentRecurringType',
        'payment_recurring_count' => 'setPaymentRecurringCount',
        'payment_amount_type' => 'setPaymentAmountType',
        'payment_start_date' => 'setPaymentStartDate',
        'payment_end_date' => 'setPaymentEndDate',
        'payment_limit_amount' => 'setPaymentLimitAmount',
        'payment_plan_id' => 'setPaymentPlanId',
        'payment_defer_days' => 'setPaymentDeferDays'
    ];
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'payment_recurring_type' => 'getPaymentRecurringType',
        'payment_recurring_count' => 'getPaymentRecurringCount',
        'payment_amount_type' => 'getPaymentAmountType',
        'payment_start_date' => 'getPaymentStartDate',
        'payment_end_date' => 'getPaymentEndDate',
        'payment_limit_amount' => 'getPaymentLimitAmount',
        'payment_plan_id' => 'getPaymentPlanId',
        'payment_defer_days' => 'getPaymentDeferDays'
    ];
    
      /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }
    

    /**
     * @internal
     * Sets payment_recurring_type
     * @param string $payment_recurring_type The frequency of the payments created as part of a payment setup. This is applicable only for recurring payment setup, in which case it is mandatory.
     * @return $this
     */
    public function setPaymentRecurringType($payment_recurring_type)
    {
        $this->payment_recurring_type = $payment_recurring_type;

        return $this;
    }

    /**
     * @internal
     * Sets payment_recurring_count
     * @param string $payment_recurring_count The maximum number of payments that can be created as part of a recurring payment setup. This cannot be specified for autopay setups.
     * @return $this
     */
    public function setPaymentRecurringCount($payment_recurring_count)
    {
        $this->payment_recurring_count = $payment_recurring_count;

        return $this;
    }

    /**
     * @internal
     * Sets payment_amount_type
     * @param string $payment_amount_type The amount type that is used to set the amount for payments created as part of a recurring payment or autopay setup. In the case of a recurring payment setup, the payment amount can be specified by the customer. In that case, the payment_amount_type should not be sent as it would default to 'other'. In the case of an autopay setup, the payment amount type is mandatory and it cannot be specified as 'other'. In this case, the payment amount should not be sent.
     * @return $this
     */
    public function setPaymentAmountType($payment_amount_type)
    {
        $this->payment_amount_type = $payment_amount_type;

        return $this;
    }

    /**
     * @internal
     * Sets payment_start_date
     * @param string $payment_start_date The date on which the first payment will be drafted as part of a recurring payment setup. This is to be specified in the ISO8601 full-date format, namely, YYYY-MM-DD. This is mandatory for recurring payment setup. This cannot be specified for autopay setups.
     * @return $this
     */
    public function setPaymentStartDate($payment_start_date)
    {
        $this->payment_start_date = $payment_start_date;

        return $this;
    }

    /**
     * @internal
     * Sets payment_end_date
     * @param string $payment_end_date The date by which the last payment will be drafted as part of a recurring payment setup. This is to be specified in the ISO8601 full-date format, namely, YYYY-MM-DD. This cannot be specified for autopay setups.
     * @return $this
     */
    public function setPaymentEndDate($payment_end_date)
    {
        $this->payment_end_date = $payment_end_date;

        return $this;
    }

    /**
     * @internal
     * Sets payment_limit_amount
     * @param string $payment_limit_amount The upper limit for the payment amount in the case of recurring or autopay payments. Any amount above the limit will not be paid automatically as part of recurring payments and autopay.
     * @return $this
     */
    public function setPaymentLimitAmount($payment_limit_amount)
    {
        $this->payment_limit_amount = $payment_limit_amount;

        return $this;
    }

    /**
     * @internal
     * Sets payment_plan_id
     * @param string $payment_plan_id The reference to the payment plan, offered by the biller, that is used to set up the recurring payment. The list of payment plans offered is published as part of the biller set-up.
     * @return $this
     */
    public function setPaymentPlanId($payment_plan_id)
    {
        $this->payment_plan_id = $payment_plan_id;

        return $this;
    }

    /**
     * @internal
     * Sets payment_defer_days
     * @param string $payment_defer_days The number of days from the bill due date that the customer wishes to delay the autopay payment by. By default an autopay payment is drafted on the bill due date.
     * @return $this
     */
    public function setPaymentDeferDays($payment_defer_days)
    {
        $this->payment_defer_days = $payment_defer_days;

        return $this;
    }


    private $payment_recurring_type;

    public function getPaymentRecurringType()
    {
        return $this->payment_recurring_type;
    }
    

    private $payment_recurring_count;
  
    public function getPaymentRecurringCount()
    {
        return $this->payment_recurring_count;
    }

    private $payment_amount_type;

    public function getPaymentAmountType()
    {
        return $this->payment_amount_type;
    }
    

    private $payment_start_date;
  
    public function getPaymentStartDate()
    {
        return $this->payment_start_date;
    }

    private $payment_end_date;
  
    public function getPaymentEndDate()
    {
        return $this->payment_end_date;
    }

    private $payment_limit_amount;
  
    public function getPaymentLimitAmount()
    {
        return $this->payment_limit_amount;
    }

    private $payment_plan_id;
  
    public function getPaymentPlanId()
    {
        return $this->payment_plan_id;
    }

    private $payment_defer_days;
  
    public function getPaymentDeferDays()
    {
        return $this->payment_defer_days;
    }

    
     /**
     * PaymentSchedule constructor.
     * @param string $payment_recurring_type 
     * @param string $payment_recurring_count 
     * @param string $payment_amount_type 
     * @param string $payment_start_date 
     * @param string $payment_end_date 
     * @param string $payment_limit_amount 
     * @param string $payment_plan_id 
     * @param string $payment_defer_days 
     */
    public function __construct($payment_recurring_type = null, $payment_recurring_count = null, $payment_amount_type = null, $payment_start_date = null, $payment_end_date = null, $payment_limit_amount = null, $payment_plan_id = null, $payment_defer_days = null)
    {
        $this->payment_recurring_type = $payment_recurring_type;
        $this->payment_recurring_count = $payment_recurring_count;
        $this->payment_amount_type = $payment_amount_type;
        $this->payment_start_date = $payment_start_date;
        $this->payment_end_date = $payment_end_date;
        $this->payment_limit_amount = $payment_limit_amount;
        $this->payment_plan_id = $payment_plan_id;
        $this->payment_defer_days = $payment_defer_days;
    }
       
    public function withPaymentLimitAmount($payment_limit_amount = null)
    {
        			$this->payment_limit_amount = $payment_limit_amount;
        		
        

        
        return $this; 
    }
    
    
    
    
	/**
     * Specify data which should be serialized to JSON
     * @link http://php.net/manual/en/jsonserializable.jsonserialize.php
     * @return mixed data which can be serialized by <b>json_encode</b>,
     * which is a value of any type other than a resource.
     * @since 5.4.0
     */
    public function jsonSerialize()
    {
        return CommonUtil::json_serialize(get_object_vars($this) );
    }
}


