<?php

/**
 * Refund
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 */

/**
 * 
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 
 */


/**
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Wrappers;

use \Orbipay\PaymentsApi\Client\ObjectSerializer;
use \Orbipay\PaymentsApi\Client\MultiMap;
use \Orbipay\PaymentsApi\Client\CommonUtil;
use Orbipay\PaymentsApi\Client\OrbipayApiException;
use lf4php\LoggerFactory;


/**
 * Refund Class Doc Comment
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 */
class Refund  extends Base 
{

	const DISCRIMINATOR = null;
    
        /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'refund_reference' => 'string', 
        'id' => 'string', 
        'url' => 'string', 
        'refund_type' => 'string', 
        'refund_amount' => 'string', 
        'fee_refund' => '\Orbipay\PaymentsApi\Client\Wrappers\FeeRefund', 
        'status' => 'string', 
        'confirmation_number' => 'string', 
        'refund_date' => 'string', 
        'refund_entry_date' => 'string', 
        'expected_refund_settlement_date' => 'string', 
        'custom_fields' => 'map[string,string]', 
        'comments' => 'string', 
        'source_payment' => '\Orbipay\PaymentsApi\Client\Wrappers\SourcePayment', 
        'payment_network_response' => '\Orbipay\PaymentsApi\Client\Wrappers\PaymentNetworkResponse', 
        'audit_info' => '\Orbipay\PaymentsApi\Client\Wrappers\AuditInfo', 
        'id_payment' => 'string', 
        'id_customer' => 'string', 
        'id_refund' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'refund_reference' => null,
        'id' => null,
        'url' => null,
        'refund_type' => null,
        'refund_amount' => null,
        'fee_refund' => null,
        'status' => null,
        'confirmation_number' => null,
        'refund_date' => null,
        'refund_entry_date' => null,
        'expected_refund_settlement_date' => null,
        'custom_fields' => null,
        'comments' => null,
        'source_payment' => null,
        'payment_network_response' => null,
        'audit_info' => null,
        'id_payment' => null,
        'id_customer' => null,
        'id_refund' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'refund_reference' => 'refund_reference',
        'id' => 'id',
        'url' => 'url',
        'refund_type' => 'refund_type',
        'refund_amount' => 'refund_amount',
        'fee_refund' => 'fee_refund',
        'status' => 'status',
        'confirmation_number' => 'confirmation_number',
        'refund_date' => 'refund_date',
        'refund_entry_date' => 'refund_entry_date',
        'expected_refund_settlement_date' => 'expected_refund_settlement_date',
        'custom_fields' => 'custom_fields',
        'comments' => 'comments',
        'source_payment' => 'source_payment',
        'payment_network_response' => 'payment_network_response',
        'audit_info' => 'audit_info',
        'id_payment' => 'ID_PAYMENT',
        'id_customer' => 'ID_CUSTOMER',
        'id_refund' => 'ID_REFUND'
    ];
    
     /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'refund_reference' => 'setRefundReference',
        'id' => 'setId',
        'url' => 'setUrl',
        'refund_type' => 'setRefundType',
        'refund_amount' => 'setRefundAmount',
        'fee_refund' => 'setFeeRefund',
        'status' => 'setStatus',
        'confirmation_number' => 'setConfirmationNumber',
        'refund_date' => 'setRefundDate',
        'refund_entry_date' => 'setRefundEntryDate',
        'expected_refund_settlement_date' => 'setExpectedRefundSettlementDate',
        'custom_fields' => 'setCustomFields',
        'comments' => 'setComments',
        'source_payment' => 'setSourcePayment',
        'payment_network_response' => 'setPaymentNetworkResponse',
        'audit_info' => 'setAuditInfo',
        'id_payment' => 'setIdPayment',
        'id_customer' => 'setIdCustomer',
        'id_refund' => 'setIdRefund'
    ];
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'refund_reference' => 'getRefundReference',
        'id' => 'getId',
        'url' => 'getUrl',
        'refund_type' => 'getRefundType',
        'refund_amount' => 'getRefundAmount',
        'fee_refund' => 'getFeeRefund',
        'status' => 'getStatus',
        'confirmation_number' => 'getConfirmationNumber',
        'refund_date' => 'getRefundDate',
        'refund_entry_date' => 'getRefundEntryDate',
        'expected_refund_settlement_date' => 'getExpectedRefundSettlementDate',
        'custom_fields' => 'getCustomFields',
        'comments' => 'getComments',
        'source_payment' => 'getSourcePayment',
        'payment_network_response' => 'getPaymentNetworkResponse',
        'audit_info' => 'getAuditInfo',
        'id_payment' => 'getIdPayment',
        'id_customer' => 'getIdCustomer',
        'id_refund' => 'getIdRefund'
    ];
    
      /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }
    

    /**
     * @internal
     * Sets refund_reference
     * @param string $refund_reference The unique identifier in the client system for the refund.
     * @return $this
     */
    public function setRefundReference($refund_reference)
    {
        $this->refund_reference = $refund_reference;

        return $this;
    }

    /**
     * @internal
     * Sets id
     * @param string $id The unique identifier assigned by Orbipay to the refund.
     * @return $this
     */
    public function setId($id)
    {
        $this->id = $id;

        return $this;
    }

    /**
     * @internal
     * Sets url
     * @param string $url This URL fetches the details of refund.
     * @return $this
     */
    public function setUrl($url)
    {
        $this->url = $url;

        return $this;
    }

    /**
     * @internal
     * Sets refund_type
     * @param string $refund_type The portion of the payment amount that is to be or has been refunded. The original payment can be refunded fully including the amount and the fee components, or partially, for just the amount or the fee component. Refund can also be initiated for an arbitrary amount limited by the original payment amount.
     * @return $this
     */
    public function setRefundType($refund_type)
    {
        $this->refund_type = $refund_type;

        return $this;
    }

    /**
     * @internal
     * Sets refund_amount
     * @param string $refund_amount The refund amount upto 2 decimal places.
     * @return $this
     */
    public function setRefundAmount($refund_amount)
    {
        $this->refund_amount = $refund_amount;

        return $this;
    }

    /**
     * @internal
     * Sets fee_refund
     * @param \Orbipay\PaymentsApi\Client\Wrappers\FeeRefund $fee_refund fee_refund
     * @return $this
     */
    public function setFeeRefund($fee_refund)
    {
        $this->fee_refund = $fee_refund;

        return $this;
    }

    /**
     * @internal
     * Sets status
     * @param string $status The status of the refund.
     * @return $this
     */
    public function setStatus($status)
    {
        $this->status = $status;

        return $this;
    }

    /**
     * @internal
     * Sets confirmation_number
     * @param string $confirmation_number The confirmation number or reference provided to the customer for the refund.
     * @return $this
     */
    public function setConfirmationNumber($confirmation_number)
    {
        $this->confirmation_number = $confirmation_number;

        return $this;
    }

    /**
     * @internal
     * Sets refund_date
     * @param string $refund_date The date on which the refund is scheduled to be made. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     * @return $this
     */
    public function setRefundDate($refund_date)
    {
        $this->refund_date = $refund_date;

        return $this;
    }

    /**
     * @internal
     * Sets refund_entry_date
     * @param string $refund_entry_date The date on which the refund captured in Orbipay. It must be in ISO8601 full-date format, namely, YYYY-MM-DD.
     * @return $this
     */
    public function setRefundEntryDate($refund_entry_date)
    {
        $this->refund_entry_date = $refund_entry_date;

        return $this;
    }

    /**
     * @internal
     * Sets expected_refund_settlement_date
     * @param string $expected_refund_settlement_date The date by which the credits would be posted to the original funding account. ISO8601 full-date format, YYYY-MM-DD
     * @return $this
     */
    public function setExpectedRefundSettlementDate($expected_refund_settlement_date)
    {
        $this->expected_refund_settlement_date = $expected_refund_settlement_date;

        return $this;
    }

    /**
     * @internal
     * Sets custom_fields
     * @param map[string,string] $custom_fields The additional information or meta-information that Orbipay can accept, maintain and transmit back to the client. The custom fields need to be configured with Orbipay before they can be accepted. Orbipay would reject custom fields that are not pre-configured. Please contact <a href = \"mailto: support@billerpayments.com\">support@billerpayments.com</a> for more information on configuring and using custom fields.
     * @return $this
     */
    public function setCustomFields($custom_fields)
    {
        $this->custom_fields = $custom_fields;

        return $this;
    }

    /**
     * @internal
     * Sets comments
     * @param string $comments Comments that can be used to recollect the operation performed on the resource object. API clients need to ensure that no sensitive information is passed in the memo. Alacriti (Orbipay) is not responsible for the security of any sensitive information that may be passed as part of the memo.
     * @return $this
     */
    public function setComments($comments)
    {
        $this->comments = $comments;

        return $this;
    }

    /**
     * @internal
     * Sets source_payment
     * @param \Orbipay\PaymentsApi\Client\Wrappers\SourcePayment $source_payment source_payment
     * @return $this
     */
    public function setSourcePayment($source_payment)
    {
        $this->source_payment = $source_payment;

        return $this;
    }

    /**
     * @internal
     * Sets payment_network_response
     * @param \Orbipay\PaymentsApi\Client\Wrappers\PaymentNetworkResponse $payment_network_response payment_network_response
     * @return $this
     */
    public function setPaymentNetworkResponse($payment_network_response)
    {
        $this->payment_network_response = $payment_network_response;

        return $this;
    }

    /**
     * @internal
     * Sets audit_info
     * @param \Orbipay\PaymentsApi\Client\Wrappers\AuditInfo $audit_info audit_info
     * @return $this
     */
    public function setAuditInfo($audit_info)
    {
        $this->audit_info = $audit_info;

        return $this;
    }

    /**
     * @internal
     * Sets id_payment
     * @param string $id_payment The unique identifier assigned by Orbipay to the payment.
     * @return $this
     */
    public function setIdPayment($id_payment)
    {
        $this->id_payment = $id_payment;

        return $this;
    }

    /**
     * @internal
     * Sets id_customer
     * @param string $id_customer The unique identifier assigned by Orbipay to the customer.
     * @return $this
     */
    public function setIdCustomer($id_customer)
    {
        $this->id_customer = $id_customer;

        return $this;
    }

    /**
     * @internal
     * Sets id_refund
     * @param string $id_refund The unique identifier assigned by Orbipay to the refund.
     * @return $this
     */
    public function setIdRefund($id_refund)
    {
        $this->id_refund = $id_refund;

        return $this;
    }


    private $refund_reference;
  
    public function getRefundReference()
    {
        return $this->refund_reference;
    }

    private $id;
  
    public function getId()
    {
        return $this->id;
    }

    private $url;
  
    public function getUrl()
    {
        return $this->url;
    }

    private $refund_type;

    public function getRefundType()
    {
        return $this->refund_type;
    }
    

    private $refund_amount;
  
    public function getRefundAmount()
    {
        return $this->refund_amount;
    }

    private $fee_refund;
  
    public function getFeeRefund()
    {
        return $this->fee_refund;
    }

    private $status;

    public function getStatus()
    {
        return $this->status;
    }
    

    private $confirmation_number;
  
    public function getConfirmationNumber()
    {
        return $this->confirmation_number;
    }

    private $refund_date;
  
    public function getRefundDate()
    {
        return $this->refund_date;
    }

    private $refund_entry_date;
  
    public function getRefundEntryDate()
    {
        return $this->refund_entry_date;
    }

    private $expected_refund_settlement_date;
  
    public function getExpectedRefundSettlementDate()
    {
        return $this->expected_refund_settlement_date;
    }

    private $custom_fields;
  
    public function getCustomFields()
    {
        return $this->custom_fields;
    }

    private $comments;
  
    public function getComments()
    {
        return $this->comments;
    }

    private $source_payment;
  
    public function getSourcePayment()
    {
        return $this->source_payment;
    }

    private $payment_network_response;
  
    public function getPaymentNetworkResponse()
    {
        return $this->payment_network_response;
    }

    private $audit_info;
  
    public function getAuditInfo()
    {
        return $this->audit_info;
    }

    private $id_payment;
  
    public function getIdPayment()
    {
        return $this->id_payment;
    }

    private $id_customer;
  
    public function getIdCustomer()
    {
        return $this->id_customer;
    }

    private $id_refund;
  
    public function getIdRefund()
    {
        return $this->id_refund;
    }

    
     /**
     * Refund constructor.
     * @param string $id_refund 
     */
    public function __construct($id_refund = null)
    {
        $this->id_refund = $id_refund;
    }
       
    public function forClient($client_key = null)
    {
		parent::forClient($client_key);
        
        return $this; 
    }
    public function videChannel($channel = null)
    {
		parent::videChannel($channel);
        
        return $this; 
    }
    public function withDetails($refund_amount = null)
    {
        			$this->refund_amount = $refund_amount;
        		
        

        
        return $this; 
    }
    public function withReference($refund_reference = null)
    {
        			$this->refund_reference = $refund_reference;
        		
        

        
        return $this; 
    }
    public function withMemo($comments = null)
    {
        			$this->comments = $comments;
        		
        

        
        return $this; 
    }
    public function withStatus($status = null)
    {
        			$this->status = $status;
        		
        

        
        return $this; 
    }
    public function forCustomer($id_customer = null)
    {
        			$this->id_customer = $id_customer;
        		
        

        
        return $this; 
    }
    public function forPayment($id_payment = null)
    {
        			$this->id_payment = $id_payment;
        		
        

        
        return $this; 
    }
    public function withCustomFields($custom_fields = null)
    {
				if(isset($custom_fields)){
					if(count($custom_fields) == 0){
						$this->custom_fields = null;
					}
					else{
        				$this->custom_fields = $custom_fields;
					}
        		}else{
        			$this->custom_fields = $custom_fields;
        		}
        		
        

        
        return $this; 
    }
    public function withFeeRefund($fee_refund = null)
    {
        			$this->fee_refund = $fee_refund;
        		
        

        
        return $this; 
    }
    
    public function createdBy($requestor = null , $requestor_type = null )
    {
       $this->requestedBy( $requestor, $requestor_type);
       return $this;
    }

    public function retrievedBy($requestor = null , $requestor_type = null )
    {
       $this->requestedBy( $requestor, $requestor_type);
       return $this;
    }

    
    public function create(InvocationContext $invocationContext, $liveMode = null,  $apiEndPoint = null)
    {
     	try {
	    	$this->withContext($invocationContext, $liveMode, $apiEndPoint);
	    	$handler = new  \Orbipay\PaymentsApi\Client\Handlers\CreateRefundHandler();
	        return $handler->process($this);
		} catch (OrbipayApiException $e) {
            throw $e;
        } catch (\Exception $e) {
             $logger = LoggerFactory::getLogger(__CLASS__);
             $logger->error($e->getMessage());
            throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
        }
    }
    public function get(InvocationContext $invocationContext, $liveMode = null,  $apiEndPoint = null)
    {
     	try {
	    	$this->withContext($invocationContext, $liveMode, $apiEndPoint);
	    	$handler = new  \Orbipay\PaymentsApi\Client\Handlers\GetRefundHandler();
	        return $handler->process($this);
		} catch (OrbipayApiException $e) {
            throw $e;
        } catch (\Exception $e) {
             $logger = LoggerFactory::getLogger(__CLASS__);
             $logger->error($e->getMessage());
            throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
        }
    }
    
    
	/**
     * Specify data which should be serialized to JSON
     * @link http://php.net/manual/en/jsonserializable.jsonserialize.php
     * @return mixed data which can be serialized by <b>json_encode</b>,
     * which is a value of any type other than a resource.
     * @since 5.4.0
     */
    public function jsonSerialize()
    {
        return CommonUtil::json_serialize(get_object_vars($this) , parent::jsonSerialize());
    }
}


