<?php

/**
 * Refunds
 *
 * PHP version 5
 *
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 */

/**
 * 
 * 
 * Generated by: https://github.com/swagger-api/swagger-codegen.git
 * Swagger Codegen version: 
 */


/**
 * Do not edit the class manually.
 */

namespace Orbipay\PaymentsApi\Client\Wrappers;

use \Orbipay\PaymentsApi\Client\ObjectSerializer;
use \Orbipay\PaymentsApi\Client\MultiMap;
use \Orbipay\PaymentsApi\Client\CommonUtil;
use Orbipay\PaymentsApi\Client\OrbipayApiException;
use lf4php\LoggerFactory;


/**
 * Refunds Class Doc Comment
 * @category Class
 * @package  Orbipay\PaymentsApi\Client
 */
class Refunds  extends Base 
{

	const DISCRIMINATOR = null;
    
        /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerTypes = [
        'list' => '\Orbipay\PaymentsApi\Client\Wrappers\Refund[]', 
        'total_results_count' => 'string', 
        'has_more_results' => 'string', 
        'url' => 'string', 
        'from_index' => 'string', 
        'to_index' => 'string', 
        'query_id' => 'string', 
        'id_customer' => 'string', 
        'confirmation_number' => 'string', 
        'status' => 'string[]', 
        'from_date' => 'string', 
        'to_date' => 'string', 
        'page_size' => 'string'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $swaggerFormats = [
        'list' => null,
        'total_results_count' => null,
        'has_more_results' => null,
        'url' => null,
        'from_index' => null,
        'to_index' => null,
        'query_id' => null,
        'id_customer' => null,
        'confirmation_number' => null,
        'status' => null,
        'from_date' => null,
        'to_date' => null,
        'page_size' => null
    ];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerTypes()
    {
        return self::$swaggerTypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function swaggerFormats()
    {
        return self::$swaggerFormats;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'list' => 'list',
        'total_results_count' => 'total_results_count',
        'has_more_results' => 'has_more_results',
        'url' => 'url',
        'from_index' => 'from_index',
        'to_index' => 'to_index',
        'query_id' => 'query_id',
        'id_customer' => 'id_customer',
        'confirmation_number' => 'confirmation_number',
        'status' => 'status',
        'from_date' => 'from_date',
        'to_date' => 'to_date',
        'page_size' => 'page_size'
    ];
    
     /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'list' => 'setList',
        'total_results_count' => 'setTotalResultsCount',
        'has_more_results' => 'setHasMoreResults',
        'url' => 'setUrl',
        'from_index' => 'setFromIndex',
        'to_index' => 'setToIndex',
        'query_id' => 'setQueryId',
        'id_customer' => 'setIdCustomer',
        'confirmation_number' => 'setConfirmationNumber',
        'status' => 'setStatus',
        'from_date' => 'setFromDate',
        'to_date' => 'setToDate',
        'page_size' => 'setPageSize'
    ];
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'list' => 'getList',
        'total_results_count' => 'getTotalResultsCount',
        'has_more_results' => 'getHasMoreResults',
        'url' => 'getUrl',
        'from_index' => 'getFromIndex',
        'to_index' => 'getToIndex',
        'query_id' => 'getQueryId',
        'id_customer' => 'getIdCustomer',
        'confirmation_number' => 'getConfirmationNumber',
        'status' => 'getStatus',
        'from_date' => 'getFromDate',
        'to_date' => 'getToDate',
        'page_size' => 'getPageSize'
    ];
    
      /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }
    
     /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }
    

    /**
     * @internal
     * Sets list
     * @param \Orbipay\PaymentsApi\Client\Wrappers\Refund[] $list list
     * @return $this
     */
    public function setList($list)
    {
        $this->list = $list;

        return $this;
    }

    /**
     * @internal
     * Sets total_results_count
     * @param string $total_results_count total number of payments available with matching criteria
     * @return $this
     */
    public function setTotalResultsCount($total_results_count)
    {
        $this->total_results_count = $total_results_count;

        return $this;
    }

    /**
     * @internal
     * Sets has_more_results
     * @param string $has_more_results true if there are more results or pages
     * @return $this
     */
    public function setHasMoreResults($has_more_results)
    {
        $this->has_more_results = $has_more_results;

        return $this;
    }

    /**
     * @internal
     * Sets url
     * @param string $url This URL fetches the next or previous set of payments, based on the presence of after_object or before_object parameter.
     * @return $this
     */
    public function setUrl($url)
    {
        $this->url = $url;

        return $this;
    }

    /**
     * @internal
     * Sets from_index
     * @param string $from_index The id of the object before which the previous set of objects are to be retrieved.
     * @return $this
     */
    public function setFromIndex($from_index)
    {
        $this->from_index = $from_index;

        return $this;
    }

    /**
     * @internal
     * Sets to_index
     * @param string $to_index The id of the object after which the next set of objects are to be retrieved.
     * @return $this
     */
    public function setToIndex($to_index)
    {
        $this->to_index = $to_index;

        return $this;
    }

    /**
     * @internal
     * Sets query_id
     * @param string $query_id The query id of the object.
     * @return $this
     */
    public function setQueryId($query_id)
    {
        $this->query_id = $query_id;

        return $this;
    }

    /**
     * @internal
     * Sets id_customer
     * @param string $id_customer The unique identifier assigned by Orbipay to the customer.
     * @return $this
     */
    public function setIdCustomer($id_customer)
    {
        $this->id_customer = $id_customer;

        return $this;
    }

    /**
     * @internal
     * Sets confirmation_number
     * @param string $confirmation_number The confirmation number provided to the customer for the refund or for the corresponding successful payment.
     * @return $this
     */
    public function setConfirmationNumber($confirmation_number)
    {
        $this->confirmation_number = $confirmation_number;

        return $this;
    }

    /**
     * @internal
     * Sets status
     * @param string[] $status The status of the refund. This can take multiple values in the format key=value1&key=value2....
     * @return $this
     */
    public function setStatus($status)
    {
        $this->status = $status;

        return $this;
    }

    /**
     * @internal
     * Sets from_date
     * @param string $from_date The date from which refunds, matching the criteria specified, need to be retrieved.
     * @return $this
     */
    public function setFromDate($from_date)
    {
        $this->from_date = $from_date;

        return $this;
    }

    /**
     * @internal
     * Sets to_date
     * @param string $to_date The date upto which refunds, matching the criteria specified, need to be retrieved.
     * @return $this
     */
    public function setToDate($to_date)
    {
        $this->to_date = $to_date;

        return $this;
    }

    /**
     * @internal
     * Sets page_size
     * @param string $page_size The maximum number of objects returned in the query.
     * @return $this
     */
    public function setPageSize($page_size)
    {
        $this->page_size = $page_size;

        return $this;
    }


    private $list;
  
    public function getList()
    {
        return $this->list;
    }

    private $total_results_count;
  
    public function getTotalResultsCount()
    {
        return $this->total_results_count;
    }

    private $has_more_results;

    public function getHasMoreResults()
    {
        return $this->has_more_results;
    }
    

    private $url;
  
    public function getUrl()
    {
        return $this->url;
    }

    private $from_index;
  
    public function getFromIndex()
    {
        return $this->from_index;
    }

    private $to_index;
  
    public function getToIndex()
    {
        return $this->to_index;
    }

    private $query_id;
  
    public function getQueryId()
    {
        return $this->query_id;
    }

    private $id_customer;
  
    public function getIdCustomer()
    {
        return $this->id_customer;
    }

    private $confirmation_number;
  
    public function getConfirmationNumber()
    {
        return $this->confirmation_number;
    }

    private $status;

    public function getStatus()
    {
        return $this->status;
    }
    

    private $from_date;
  
    public function getFromDate()
    {
        return $this->from_date;
    }

    private $to_date;
  
    public function getToDate()
    {
        return $this->to_date;
    }

    private $page_size;
  
    public function getPageSize()
    {
        return $this->page_size;
    }

    
       
    public function forClient($client_key = null)
    {
		parent::forClient($client_key);
        
        return $this; 
    }
    public function videChannel($channel = null)
    {
		parent::videChannel($channel);
        
        return $this; 
    }
    public function findBy(MultiMap $filterMap = null)
    {
        
        
		$id_customer_values = $filterMap->get('id_customer');
		if ($id_customer_values !== null && count($id_customer_values) > 0) {
        	$this->id_customer = end($id_customer_values);
		}
        
        
		$confirmation_number_values = $filterMap->get('confirmation_number');
		if ($confirmation_number_values !== null && count($confirmation_number_values) > 0) {
        	$this->confirmation_number = end($confirmation_number_values);
		}
        
        
		$from_date_values = $filterMap->get('from_date');
		if ($from_date_values !== null && count($from_date_values) > 0) {
        	$this->from_date = end($from_date_values);
		}
        
        
		$to_date_values = $filterMap->get('to_date');
		if ($to_date_values !== null && count($to_date_values) > 0) {
        	$this->to_date = end($to_date_values);
		}
        
		$status_values = $filterMap->get('status');
		if ($status_values !== null) {
        	$this->status = array_unique($status_values);
    	}
            	
        
        
		$page_size_values = $filterMap->get('page_size');
		if ($page_size_values !== null && count($page_size_values) > 0) {
        	$this->page_size = end($page_size_values);
		}
        
        
		$query_id_values = $filterMap->get('query_id');
		if ($query_id_values !== null && count($query_id_values) > 0) {
        	$this->query_id = end($query_id_values);
		}
        
        
		$from_index_values = $filterMap->get('from_index');
		if ($from_index_values !== null && count($from_index_values) > 0) {
        	$this->from_index = end($from_index_values);
		}
        
        
		$to_index_values = $filterMap->get('to_index');
		if ($to_index_values !== null && count($to_index_values) > 0) {
        	$this->to_index = end($to_index_values);
		}
        
        return $this; 
    }
    public function forCustomer($id_customer = null)
    {
        			$this->id_customer = $id_customer;
        		
        

        
        return $this; 
    }
    
    public function retrievedBy($requestor = null , $requestor_type = null )
    {
       $this->requestedBy( $requestor, $requestor_type);
       return $this;
    }

    
    public function get(InvocationContext $invocationContext, $liveMode = null,  $apiEndPoint = null)
    {
     	try {
	    	$this->withContext($invocationContext, $liveMode, $apiEndPoint);
	    	$handler = new  \Orbipay\PaymentsApi\Client\Handlers\RetrieveRefundsHandler();
	        return $handler->process($this);
		} catch (OrbipayApiException $e) {
            throw $e;
        } catch (\Exception $e) {
             $logger = LoggerFactory::getLogger(__CLASS__);
             $logger->error($e->getMessage());
            throw new OrbipayApiException($e->getMessage(), $e->getCode(), $e);
        }
    }
    
    
	/**
     * Specify data which should be serialized to JSON
     * @link http://php.net/manual/en/jsonserializable.jsonserialize.php
     * @return mixed data which can be serialized by <b>json_encode</b>,
     * which is a value of any type other than a resource.
     * @since 5.4.0
     */
    public function jsonSerialize()
    {
        return CommonUtil::json_serialize(get_object_vars($this) , parent::jsonSerialize());
    }
}


